//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****     KTIME - AVRIL 2005 - CopyRight  XCS Corporation		*****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                (enfin...)        *****
//***************************************************************************
//***************************************************************************
#ifndef __KTIME
#define __KTIME

#include "XDSFree.h"
#include <GL\gl.h>
#include <GL\glu.h>
#include <windows.h>


extern int      KTime  [256];  //modifiable pour rptition de touche
extern float    tact;


//*****************************************************************************
//***  TypeK  *****************************************************************
//*****************************************************************************

class TypeK { public :
        float   fps,dtime;  // dtime est en SECONDES, crtin

        char    Keys    [256];
        int     kAction;

        HINSTANCE hInstance;
        HWND      hWnd;
        float   FaCt01;
        float   fAcT01;

        bool KeyPressed();                      // true ssi n'importe quoi est enfonc, depuis n'importe quand
        int  KeyPressed1(bool SaufCtShAl);      // si KTime == 1  , a renvoie la 1re touche enfonce dtecte.

        inline float sact(float a) {return((float)sin(tact/1000*a*6.283));}
        inline float cact(float a) {return((float)cos(tact/1000*a*6.283));}
        inline float sact(float a,float phi) {return((float)sin(tact/1000.0f*a*6.283+phi));}
        inline float cact(float a,float phi) {return((float)cos(tact/1000.0f*a*6.283+phi));}
        void    ShowMessage(LPTSTR lpszFunction); // Fonction Windows utile

 private :
        void    InitFPS();
        void    InitKTime();
        float   Clock();

        void    RefreshFPS();
        void    RefreshKTime();
        float   t1,t2,oldtact;
        int     frame;
        int     KTime2  [256];  //seconde copie  ne pas modifier
        char    OldKeys [256];
        __int64 CountPerSecond,CountIni,CountAct;

 public :
        void Refresh() {RefreshFPS(); RefreshKTime();}
        TypeK(){FaCt01=fAcT01=1; kAction=0; InitFPS(); InitKTime();}
} extern K;




//*****************************************************************************
//** TFenetreGL ***************************************************************
//*****************************************************************************


class TFenetreGL {
public :
                //--- Spcial Mthode Windows
                HWND		hWnd;		        // Holds Our Window Handle
                HINSTANCE	hInstance;		// Holds The Instance Of The Application
                bool	active;
                bool	fullscreen;
                void InitFenetre(char * title, int width=640, int height=480, int bits=32, bool fullscreenflag=false);
                void Resize(int PosX, int PosY, int TX, int TY);
                float Width, Height;
                float tx() {return(Width) ;}
                float ty() {return(Height);}
                float xC() {return(tx()/2);}
                float yC() {return(ty()/2);}
                void Activate()                 { wglMakeCurrent(hdc , hrc);}
                void DrawEssai();
                void SetProjMatrPixels()        { glMatrixMode  (GL_PROJECTION);glLoadIdentity(); gluOrtho2D(0,tx(),0,ty());glMatrixMode(GL_MODELVIEW); }; // (0,0)=BAS GAUCHE
                void SwapBuff()                 { SwapBuffers   (this->hdc); };
                void SetFullScreen(bool ON,int TX0=0,int TY0=0);
                void SetCaption   (bool ON);

                POINT EcranIni;
                POINT SizeBeforeFullScr;        // n'est initialis que si on fait FullScreen, sinon non.

                TFenetreGL() {  EcranIni.x = GetSystemMetrics(SM_CXSCREEN);
                                EcranIni.y = GetSystemMetrics(SM_CYSCREEN);
                                SizeBeforeFullScr.x=500;        SizeBeforeFullScr.x=300; }

                private :
                HDC   hdc;
                HGLRC hrc;
} extern F;


//*****************************************************************
//***  TSouris  ***************************************************
//*****************************************************************


enum {
        M_LEFT   = 0,
        M_RIGHT  = 1,
        M_MIDDLE = 2
};
class TSouris {public :
                //--- Valeurs mises  jour par Refresh()
                int     x,y;
                int oldx,oldy; // non utilis par TSouris. Prsent juste pour l'utilisateur.
                int     MTime[3];

                //--- Utiliss par WndProc
                int  Nx,Ny;
                bool ButtonL, ButtonR, ButtonM;
                int  zDelta; // Molette de la souris. Remettre  0 aprs chq usage. WHEEL_DELTA = 120 = 1 cran

                TSouris(){ Nx=-1;oldx=-1; ButtonL=ButtonR=ButtonM=false; zDelta=0; Refresh(); };

                void OnMove(int nx, int ny) {Nx=nx; Ny=F.ty()-ny;}     // Appele par WndProc
                void Refresh();                                 //  faire  chaque tour de boucle.

                bool In  (float x1, float y1, float x2, float y2) {return (DD.InRect(x    ,y    ,x1,y1,x2,y2));}
                bool In  (TXRect &R)                              {return (DD.InRect(x    ,y    ,R.x1,R.y1,R.x2,R.y2));}
                bool In11(float x1, float y1, float x2, float y2) {return (DD.InRect(x11(),y11(),x1,y1,x2,y2));}

                bool OnClick(int x1, int y1, int x2, int y2)  {return (MTime[M_LEFT]==1 && DD.InRect(x,y,x1,y1,x2,y2));}
                bool LeftClick   () {return(MTime[M_LEFT] ==1);}
                bool LeftEnfonce () {return(MTime[M_LEFT] >=1);}

                bool OnClickR(int x1, int y1, int x2, int y2) {return (MTime[M_RIGHT]==1 && DD.InRect(x,y,x1,y1,x2,y2));}
                bool RightClick  () {return(MTime[M_RIGHT]==1);}
                bool RightEnfonce() {return(MTime[M_RIGHT]>=1);}

                bool OnClickM(int x1, int y1, int x2, int y2) {return (MTime[M_MIDDLE]==1 && DD.InRect(x,y,x1,y1,x2,y2));}
                bool MiddleClick  () {return(MTime[M_MIDDLE]==1);}
                bool MiddleEnfonce() {return(MTime[M_MIDDLE]>=1);}

                float Width()  {return(F.Width); }
                float Height() {return(F.Height);}      // Taille de l'cran en pixels...
                float x11() { return (  (x-(Width() *0.5)) / (Width() *0.5) ); }
                float y11() { return ( -(y-(Height()*0.5)) / (Height()*0.5) ); }
                string StrMouse();  string StrOldMouse();
};
extern TSouris Souris;



//*****************************************************************
//***  float_time  ************************************************
//*****************************************************************

class float_time { public :
                                float ini,  fin, tini, duree;
                        	float a();	// calcule la valeur act
                                int Type;       // cf ci-dessus

                        	float * ptact ;  // Pointe vers la variable tact globale.
                        	float modulo ;   // si 0 alors rien, sinon ini et fin sont modulo le modulo

                                void Fixe(float f);     // De faon instantane, fixe le float_time  la valeur en param
                                void Over() {ini=fin;}  // De faon instantane, amne la variable  la FIN
                                float_time(float Ini=0,float duree1000=1000, int Type0=0, float * ptact=&tact, float modulo=0);
                                void operator = (float Val);
                                void SetIfDiff(float Val) {if (fin!=Val) *this=Val;}

//                                float_time& operator = (float_time& , float_time& );
//                                friend float& operator = (float& , float_time& );
};

// float_time Ess1 = float_time(2,500);          Exemple d'utilisation
// float_time Ess2 = 3;                          Exemple d'utilisation

// Type float_time 0 = linaire
// Type float_time 1 = ini  fin  ini, en quadratique
// Type float_time 2 = ini  fin, en consinus



#define K_BACK 8
#define K_TAB 9
#define K_VERRMAJ 20
#define K_ENTER 13
#define K_ESPACE 32
#define K_SPACE 32
#define K_ESC 27
#define K_ECHAP 27
#define K_ESCAPE 27
#define K_SHIFT 16
#define K_SHIFTG 160
#define K_SHIFTD 161
#define K_STRICT 226
#define K_CTRL 17
#define K_CTRLG 162
#define K_CTRLD 163
#define K_LEFT 37
#define K_UP 38
#define K_RIGHT 39
#define K_DOWN 40
#define K_ALT 18
#define K_ALTGR 165
// Attention AltGR appuie aussi sur "shift"

#define K_INSER 45
#define K_SUPPR 46
#define K_FIN	35
#define K_DEBUT	36
#define K_CARRE	222


//Alt et 65 ecrit un 'A'
#define K_A 65
#define K_B 66
#define K_C 67
#define K_D 68
#define K_E 69
#define K_F 70
#define K_G 71
#define K_H 72
#define K_I 73
#define K_J 74
#define K_K 75
#define K_L 76
#define K_M 77
#define K_N 78
#define K_O 79
#define K_P 80
#define K_Q 81
#define K_R 82
#define K_S 83
#define K_T 84
#define K_U 85
#define K_V 86
#define K_W 87
#define K_X 88
#define K_Y 89
#define K_Z 90

//Les 0..9 ci dessous sont ceux au dessus des lettres, pas le clavier numrique. Banane.
#define K_0 48
#define K_1 49
#define K_2 50
#define K_3 51
#define K_4 52
#define K_5 53
#define K_6 54
#define K_7 55
#define K_8 56
#define K_9 57
#define K_NUMERO 219
#define K_EGAL 187

#define K_PAGEUP 33
#define K_PAGEDOWN 34
#define K_F1 112
#define K_F2 113
#define K_F3 114
#define K_F4 115
#define K_F5 116
#define K_F6 117
#define K_F7 118
#define K_F8 119
#define K_F9 120
#define K_F10 121
#define K_F11 122
#define K_F12 123

#define K_PUISSANCE 221
#define K_PUISS     221
#define K_DOLLAR 186

#define K_POURCENT 192
#define K_MU 220

#define K_VIRGULE 188
#define K_POINT 190
#define K_DIVISE 191
#define K_EXCLAMATION 223

//Clavier numrique
#define K_CNDIVISE  111
#define K_CNFOIS    106
#define K_CNMOINS   109
#define K_CNPLUS    107
#define K_CNPOINT   110
#define K_CN0    96
#define K_CN1    97
#define K_CN2    98
#define K_CN3    99
#define K_CN4    100
#define K_CN5    101
#define K_CN6    102
#define K_CN7    103
#define K_CN8    104
#define K_CN9    105


#endif
