//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      XDS GL - MARS 2002 - CopyRight  XDS Corporation		*****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************
#include "XCSGL.h"

Tgl   gl;
Tglut glut;
TXYZ  XYZ;

//***************************************************************************
//******** gl  **************************************************************
//***************************************************************************

void Tgl::SetScreen2D(int Width,int Height,bool ZeroEnHaut)
{
        glViewport(0,0,Width,Height);
        glMatrixMode(GL_PROJECTION);glLoadIdentity();
        if (ZeroEnHaut) {gluOrtho2D(0,Width,Height,0);}
                else    {gluOrtho2D(0,Width,0,Height);}
        glMatrixMode(GL_MODELVIEW);
}
//---------------------------------------------------------------------------
void Tgl::Restart()
{
    glDisable   (GL_BLEND);    glMatrixMode(GL_MODELVIEW);    glEnable	(GL_DEPTH_TEST);
    glEnable	(GL_TEXTURE_2D);
    glTexEnvi	(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE); //### On peut mettre GL_BLEND ou GL_MODULATE ou GL_DECAL(comme GL_MODULATE?)
    glShadeModel(GL_FLAT);					   //### On peut mettre GL_SMOOTH, a gre le dgrad de couleur (cf aiguille de la montre du prgm dmo)
    glDisable(GL_TEXTURE_GEN_S);        glDisable(GL_TEXTURE_GEN_T);
    glDisable(GL_LIGHTING);             glDisable(GL_LIGHT0);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
}
//---------------------------------------------------------------------------
void Tgl::CubeTex             (float x,float y,float z,float tx,float ty,float tz,int Texture)
{
	if (Texture!=-1) {glTexture(Texture);}
	glPushMatrix();
	glTranslatef(x,y,z);
	glBegin(GL_QUADS);
	t2f(0,0);v3f(0,0,0);t2f(1,0);v3f(tx,0,0);t2f(1,1);v3f(tx,ty,0);t2f(0,1);v3f(0,ty,0);
	t2f(0,0);v3f(0,0,0);t2f(1,0);v3f(tx,0,0);t2f(1,1);v3f(tx,0,tz);t2f(0,1);v3f(0,0,tz);
	t2f(0,0);v3f(0,0,0);t2f(1,0);v3f(0,0,tz);t2f(1,1);v3f(0,ty,tz);t2f(0,1);v3f(0,ty,0);

	t2f(0,0);v3f(tx,ty,tz);t2f(1,0);v3f(tx,ty,0);t2f(1,1);v3f(tx,0,0);t2f(0,1);v3f(tx,0,tz);
	t2f(0,0);v3f(tx,ty,tz);t2f(1,0);v3f(0,ty,tz);t2f(1,1);v3f(0,ty,0);t2f(0,1);v3f(tx,ty,0);
	t2f(0,0);v3f(tx,ty,tz);t2f(1,0);v3f(tx,0,tz);t2f(1,1);v3f(0,0,tz);t2f(0,1);v3f(0,ty,tz);
	glEnd();
	glPopMatrix();
}
//---------------------------------------------------------------------------
void Tgl::CubeTexCentre  (float x,float y,float z,float tx,float ty,float tz,int Texture)
{
        CubeTex(x-tx/2,y-ty/2,z-tz/2,tx,ty,tz,Texture);
}
//---------------------------------------------------------------------------
void CarreRondSLOW(float xC, float yC, float z, float tx, float ty, float factRond,int NbLam15,GLuint tex)
{       if ((tx==0)||(ty==0)) return;
        if (tex!=(uint)-1) glTexture(tex);
        tx*=0.5;
        ty*=0.5;
        float trond = MIN(tx,ty)*factRond;    // Taille du rond
        float xrond = tx-trond;        // y o commence le rond
        float yrond = ty-trond;        // y o commence le rond
        float f=0.5; float ff=0.5;
        glBegin(GL_QUAD_STRIP);
        for (int k=0; k<=NbLam15; k++)
        {
                float tet=k*3.14159*0.5/NbLam15;
                t2f(   (- xrond - trond*cos(tet))/tx*f+ff ,     (+ yrond + trond*sin(tet))/ty*f+ff );
                v3f( xC - xrond - trond*cos(tet)          ,  yC  + yrond + trond*sin(tet)             ,z);
                t2f(   (- xrond - trond*cos(tet))/tx*f+ff ,     (- yrond - trond*sin(tet))/ty*f+ff );
                v3f( xC - xrond - trond*cos(tet)          ,  yC  - yrond - trond*sin(tet)             ,z);
        }
        t2f ( -xrond/tx*f+ff,  1); v3f(xC-xrond, yC+ty, z);        t2f ( -xrond/tx*f+ff,  0);  v3f(xC-xrond, yC-ty, z);
        t2f (  xrond/tx*f+ff,  1); v3f(xC+xrond, yC+ty, z);        t2f (  xrond/tx*f+ff,  0);  v3f(xC+xrond, yC-ty, z);
        for (int k=0; k<=NbLam15; k++)
        {
                float tet=(NbLam15-k)*3.14159*0.5/NbLam15;
                t2f(   (xrond + trond*cos(tet))/tx*f+ff ,     (+ yrond + trond*sin(tet))/ty*f+ff );                v3f(xC + xrond + trond*cos(tet) , yC  + yrond + trond*sin(tet) ,z);
                t2f(   (xrond + trond*cos(tet))/tx*f+ff ,     (- yrond - trond*sin(tet))/ty*f+ff );                v3f(xC + xrond + trond*cos(tet) , yC  - yrond - trond*sin(tet) ,z);
        }
        glEnd();
}
//---------------------------------------------------------------------------
#define NBLAMMAX 30
float v3fCarre[3* 2*NBLAMMAX *3]; // lamelles droite, milieu, gauche
float t2fCarre[3* 2*NBLAMMAX *2]; // lamelles droite, milieu, gauche
//#define TTt2f(a,b) t2f(a,b)
//#define VVv3f(a,b,c) v3f(a,b,c)
#define TTt2f(a,b)    *t2fAct++ = a;  *t2fAct++ = b
#define VVv3f(a,b,c)  *v3fAct++ = a;  *v3fAct++ = b;  *v3fAct++ = c
void Tgl::CarreRond(float xC, float yC, float z, float tx, float ty, float factRond,int NbLam15,GLuint tex)
{       if (NbLam15>NBLAMMAX) NbLam15=NBLAMMAX;
        if ((tx==0)||(ty==0)) return;
        if (tex!=(uint)-1) glTexture(tex);
        tx*=0.5;
        ty*=0.5;
        float trond = MIN(tx,ty)*factRond;    // Taille du rond
        float xrond = tx-trond;        // y o commence le rond
        float yrond = ty-trond;        // y o commence le rond
        float f=0.5; float ff=0.5;

        //glBegin(GL_QUAD_STRIP);
        float tet,tct,tst;
        float * v3fAct = v3fCarre;
        float * t2fAct = t2fCarre;
        for (int k=0; k<=NbLam15; k++)
        {
                tet=k*3.14159*0.5/NbLam15; tct=trond*cos(tet); tst=trond*sin(tet);
                TTt2f(   (- xrond - tct)/tx*f+ff ,     (+ yrond + tst)/ty*f+ff );
                VVv3f( xC - xrond - tct          ,  yC  + yrond + tst             ,z);
                TTt2f(   (- xrond - tct)/tx*f+ff ,     (- yrond - tst)/ty*f+ff );
                VVv3f( xC - xrond - tct          ,  yC  - yrond - tst             ,z);
        }
        TTt2f ( -xrond/tx*f+ff,  1); VVv3f(xC-xrond, yC+ty, z);        TTt2f ( -xrond/tx*f+ff,  0);  VVv3f(xC-xrond, yC-ty, z);
        TTt2f (  xrond/tx*f+ff,  1); VVv3f(xC+xrond, yC+ty, z);        TTt2f (  xrond/tx*f+ff,  0);  VVv3f(xC+xrond, yC-ty, z);
        for (int k=0; k<=NbLam15; k++)
        {
                tet=k*3.14159*0.5/NbLam15; tct=trond*cos(tet); tst=trond*sin(tet);
                TTt2f(   (xrond + tct)/tx*f+ff ,  (+ yrond + tst)/ty*f+ff );        VVv3f(xC + xrond + tct , yC  + yrond + tst ,z);
                TTt2f(   (xrond + tct)/tx*f+ff ,  (- yrond - tst)/ty*f+ff );        VVv3f(xC + xrond + tct , yC  - yrond - tst ,z);
        }
        //glEnd();

        glEnableClientState (GL_VERTEX_ARRAY);
        glEnableClientState (GL_TEXTURE_COORD_ARRAY);
        glVertexPointer     (3, GL_FLOAT, 0, v3fCarre);
        glTexCoordPointer   (2, GL_FLOAT, 0, t2fCarre);

        glDrawArrays ( GL_QUAD_STRIP, 0, (NbLam15+1)*2*2 + 4  );

        glDisableClientState(GL_VERTEX_ARRAY);
        glDisableClientState(GL_TEXTURE_COORD_ARRAY);
}
//---------------------------------------------------------------------------
void Tgl::CarrezCST2RotzCentre(float x1,float y1,float tx,float ty,float z,float Rot90,GLuint Texture)
  {
	if ((int)Texture!=-1) glTexture(Texture);
	glPushMatrix();
	glTranslated(x1,y1,z);
	glRotated(Rot90,0,0,1);

	glBegin(GL_QUADS);
	t2f(0,0);v3f(-tx/2,-ty/2,0);
	t2f(1,0);v3f(+tx/2,-ty/2,0);
	t2f(1,1);v3f(+tx/2,+ty/2,0);
	t2f(0,1);v3f(-tx/2,+ty/2,0);
	glEnd();
	glPopMatrix();
}
//---------------------------------------------------------------------------
void Tgl::CubeRondXELIM(float xC,float yC,float z,float tx,float ty,float tz, float FactRond, int NbLam15,
			   float toui,float tnon,float thoche, GLuint TexFace,GLuint TexAutre)
{
        glPushMatrix();
        tx/=2;    ty/=2;
        float x2=tx; float y2=ty; float z2=tz/2;
	glTranslatef(xC,yC,z -(ABS(z2)) ); // on dessine un cube centr, mais z = coord de l'ECRAN
	RotateAff(toui    ,1,0,0   ,0,0,0 );
	RotateAff(thoche  ,0,0,1   ,0,0,0 );
	RotateAff(tnon    ,0,1,0   ,0,0,0 );
	CarreRond( 0,0,-z2,tx*2,ty*2,FactRond,NbLam15,TexAutre);
      	CarreRond( 0,0, z2,tx*2,ty*2,FactRond,NbLam15,TexFace);
        if (TexAutre!=(uint)-1) glTexture(TexAutre);
        float trond = MIN(tx,ty)*FactRond;    // Taille du rond
        float xrond = tx-trond;        // y o commence le rond
        float yrond = ty-trond;        // y o commence le rond
	glBegin(GL_QUADS);t2f(0,0);v3f(-xrond,-y2,-z2);t2f(1,0);v3f(xrond,-y2,-z2);t2f(1,1);v3f(xrond,-y2,z2);t2f(0,1);v3f(-xrond, -y2,z2);glEnd(); // dessous
	glBegin(GL_QUADS);t2f(0,0);v3f(-xrond,+y2,-z2);t2f(1,0);v3f(xrond,+y2,-z2);t2f(1,1);v3f(xrond,+y2,z2);t2f(0,1);v3f(-xrond, +y2,z2);glEnd(); // dessus

	glBegin(GL_QUADS);t2f(0,0);v3f(-x2,+yrond,-z2);t2f(1,0);v3f(-x2,+yrond,+z2);t2f(1,1);v3f(-x2,-yrond,z2);t2f(0,1);v3f(-x2, -yrond,-z2);glEnd(); // gauche
	glBegin(GL_QUADS);t2f(0,0);v3f(+x2,+yrond,-z2);t2f(1,0);v3f(+x2,+yrond,+z2);t2f(1,1);v3f(+x2,-yrond,z2);t2f(0,1);v3f(+x2, -yrond,-z2);glEnd(); // droite

        glBegin(GL_QUAD_STRIP);
        for (int k=0; k<=NbLam15; k++)
        {       float tet=k*3.14159*0.5/NbLam15;
                t2f(0,   k /(float)NbLam15 );v3f(-xrond-trond*cos(tet),yrond+trond*sin(tet), z2);    t2f(tz,(k+1)/(float)NbLam15 );v3f(-xrond-trond*cos(tet),yrond+trond*sin(tet),-z2);
        }
        glEnd();
        glBegin(GL_QUAD_STRIP);
        for (int k=0; k<=NbLam15; k++)
        {       float tet=(NbLam15-k)*3.14159*0.5/NbLam15;
                t2f(0,   k /(float)NbLam15 );v3f( xrond+trond*cos(tet),yrond+trond*sin(tet), z2);    t2f(tz,(k+1)/(float)NbLam15 );v3f(+xrond+trond*cos(tet),yrond+trond*sin(tet),-z2);
        }
        glEnd();
        glBegin(GL_QUAD_STRIP);
        for (int k=0; k<=NbLam15; k++)
        {       float tet=(NbLam15-k)*3.14159*0.5/NbLam15;
                t2f(0,   k /(float)NbLam15 );v3f( xrond+trond*cos(tet),-yrond-trond*sin(tet), z2);    t2f(tz,(k+1)/(float)NbLam15 );v3f(+xrond+trond*cos(tet),-yrond-trond*sin(tet),-z2);
        }
        glEnd();
        glBegin(GL_QUAD_STRIP);
        for (int k=0; k<=NbLam15; k++)
        {       float tet=k*3.14159*0.5/NbLam15;
                t2f(0,   k /(float)NbLam15 );v3f(-xrond-trond*cos(tet),-yrond-trond*sin(tet), z2);    t2f(tz,(k+1)/(float)NbLam15 );v3f(-xrond-trond*cos(tet),-yrond-trond*sin(tet),-z2);
        }
        glEnd();
        glPopMatrix();
}

void Tgl::ScreenShot(char * NomFich)
{
	unsigned char * Pix;
	Pix=(unsigned char*)malloc( F.Width * F.Height * 3 );
	glReadPixels(0,0,F.Height,F.Height,GL_RGB,GL_UNSIGNED_BYTE,Pix);
//        XLoader.SaveBMP(F.Width,F.Height,NomFich,Pix);
	free(Pix);
}
void Sphere00(float r,int NbEta,int NbMer)
{
	int kx,ky;
	float rUp,rDown,yu,yd,xl,xr,yUp,yDown;
	glBegin(GL_QUADS);
  	for (ky=0;ky<NbEta;ky++)
	{
		yu	=(float)(ky)/NbEta;
		yd	=(float)(ky+1)/NbEta;
		rUp	=r*sin(yu*PI);		rDown	=r*sin(yd*PI);
		yUp	=r*cos(yu*PI);		yDown	=r*cos(yd*PI);
		for (kx=0;kx<NbMer;kx++)
		{
                    xl	=(float)(kx)/NbMer;
                    xr	=(float)(kx+1)/NbMer;
                    glTexCoord2f(1-xl,1-yu);v3f(cos(xl*2*PI)*rUp	,yUp	,sin(xl*2*PI)*rUp );
                    glTexCoord2f(1-xr,1-yu);v3f(cos(xr*2*PI)*rUp	,yUp	,sin(xr*2*PI)*rUp );
                    glTexCoord2f(1-xr,1-yd);v3f(cos(xr*2*PI)*rDown,yDown	,sin(xr*2*PI)*rDown );
                    glTexCoord2f(1-xl,1-yd);v3f(cos(xl*2*PI)*rDown,yDown	,sin(xl*2*PI)*rDown );
		}
	}
	glEnd();
}
//*************************************************
void Tgl::Sphere(float x,float y,float z,float r,int NbEta20,int NbMer20,GLuint TexSphere,float translx,float transly)
{
	glTexture(TexSphere);
	glMatrixMode(GL_MODELVIEW);	glPushMatrix();	glTranslatef(x,y,z);
	glMatrixMode(GL_TEXTURE);	glPushMatrix();	glTranslated(translx,transly,0);
	Sphere00( r,NbEta20,NbMer20);
	glMatrixMode(GL_TEXTURE);	glPopMatrix();
        glMatrixMode(GL_MODELVIEW);	glPopMatrix();
}
#define INIT_Draw(R,V,B) glDisable(GL_TEXTURE_2D);glDisable(GL_DEPTH_TEST);glPointSize(size);ColorON(R,V,B)
#define QUIT_Draw        glEnable (GL_TEXTURE_2D);glEnable (GL_DEPTH_TEST)

void Tgl::DrawPt2D(int x1,int y1,          float size,float R,float V,float B)                              {INIT_Draw(R,V,B);   glBegin(GL_POINTS);v2f(x1,y1);glEnd();                       QUIT_Draw;}
void Tgl::DrawPt3D(float x,float y,float z,float size,float R,float V,float B)                              {INIT_Draw(R,V,B);   glBegin(GL_POINTS);v3f(x,y,z);glEnd();                       QUIT_Draw;}
void Tgl::Line    (float x,float y,float z,float xx,float yy,float zz,float R, float V, float B,float size) {INIT_Draw(R,V,B);   glLineWidth(size);glBegin(GL_LINES); v3f(x,y,z); v3f(xx,yy,zz); glEnd();       QUIT_Draw;}
void Tgl::DrawRect (TXRect &R    ,float size,float RR,float V,float B)
{
        INIT_Draw(RR,V,B); glBegin(GL_LINE_LOOP); v2f(R.x1,R.y1);v2f(R.x2,R.y1);v2f(R.x2,R.y2);v2f(R.x1,R.y2); glEnd(); QUIT_Draw;
}
void Tgl::DrawRect (float x1,float y1, float x2,float y2, float size,float RR,float V,float B) {
        TXRect R(x1,y1,x2,y2);
        DrawRect( R,size,RR,V,B);}

//**********************************************************
//***** 9.9 **** TGV : Type GL Vars ************************
//**********************************************************
class TGV { public :
        TGV();
        void GetVars();
        void SetVars();

        bool ET, EB; // (Enable Texture) (Enable Blend)
        int  SM, EM; // (Shade Model)    (Env Mode)
        float C[4];  // (Color)
};
TGV::TGV() {GetVars();}
void TGV::GetVars()
{
        ET=glIsEnabled( GL_TEXTURE_2D);
        EB=glIsEnabled( GL_BLEND);
        glGetIntegerv ( GL_SHADE_MODEL, &SM);
        glGetTexEnviv ( GL_TEXTURE_ENV , GL_TEXTURE_ENV_MODE, &EM );
        glGetFloatv   ( GL_CURRENT_COLOR,C);
}
void TGV::SetVars()
{
	glEnableVar  (ET,GL_TEXTURE_2D);
	glEnableVar  (EB,GL_BLEND);
        glShadeModel (SM);
        glTexEnvi    (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, EM);
        glColor4f(C[0],C[1],C[2],C[3]);
}

//**********************************************************
//***** 8 **** PIANO ***************************************
//**********************************************************
int TabloPiano [20] = {16,226,81,87,83,88,67,70,86,71,66,72,78,188,75,190,76,191,223,192};
int Tablo2Piano[22] = {65,50,90,51,69,82,53,84,54,89,55,85,73,57,79,48,80,221,187,186,8,13};
//**********************************************************
void InitPiano(TPiano * P,float tx1Case,float ty,float tz,GLuint TexNoire,GLuint TexBlanc,int NbTouches18)
{
	P->tx=tx1Case;
	P->ty=ty;
	P->tz=tz;
	P->TexBlanc=TexBlanc;
	P->TexNoire=TexNoire;
	P->NbTouches37=NbTouches18;
	FillChar(P->K,sizeof(P->K),0);
}
int Key2NoteDT (WORD Key)  // renvoie 0=si, 1=Do, 2=Do# ... etc
{
	int k;
	for (k=0;k<20;k++) if (Key==TabloPiano [k]) return (k);
	for (k=0;k<22;k++) if (Key==Tablo2Piano[k]) return (k+13);
	return(-1);
}
//*** On passe la coordonne la + en bas  gauche, devant.
void DrawPiano (TPiano * P)
{
	float x,y,z,tx,ty,tz;
	x =P->x;	y =P->y;	z =P->z;
        tx=P->tx;	ty=P->ty;	tz=P->tz;
	int note;
	bool Noire;
	float ff;
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(x,y,z);
	gl.RotateAff(P->TetHoche,tx*1.05*P->NbTouches37/3.5,0,-tz/2,tx*1.05*P->NbTouches37/3.5,0,0);
	glRotatef  (P->TetNon  ,0,1,0);
	glRotatef  (P->TetOui  ,1,0,0);
	x=0;y=0;z=0;
	for (int k=1;k<P->NbTouches37;k++)
	{
		ff=(float)P->K[k]/100;
		note=(k-1)%12; //*** RAPPEL : 0=Si, 1=Do, 2=Do#
		Noire=note;
		if (!Noire)
		{
			glTexture(P->TexBlanc);
			gl.CubeTex(x,y-ty*ff,z,tx,ty,-tz,-1);
			x+=tx*1.05;
		}
		else
		{
			glTexture(P->TexNoire);
			gl.CubeTex(x-tx/2,y+(ty/1.2)-(ty/1.9)*ff,z-tz/2   ,   tx*0.7,ty*0.8,-tz*0.5,-1);
		}
		if (P->K[k])
		{
			P->K[k]-=10;
		}

	}
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

}
//**********************************************************
//***** 11bis *** TGLBombe *********************************
//**********************************************************

void TGLBombe::Draw (float xC,float yC,float z, float txBombe, float yFil01, int Typ012, int kAction) // Typ012 : 0=PasExpl 1=ExplModulo 2=ExplVaEtVient
{
        gl.EnableSpr();glDisable(GL_DEPTH_TEST);
        gl.CarrezCST2Centre( xC,yC,txBombe,txBombe, z,TexBombe); // La bombe fait 128*128 pixels, le fil fait 32*1024, l'expl fait 64*64
        glTexture(TexCorde);
        float yFilTOT = txBombe*1024/128.0;
        float tx      = txBombe*  32/128.0 *0.5;
        float te      = txBombe * 64/128.0 *2.8;
        xC+=tx*0.3;
        float yUp=yC+txBombe/2 + yFil01*yFilTOT     *2.9;
        glBegin(GL_QUADS);
          t2f(0,0);       v3f(xC-tx, yC+txBombe/2,z);
          t2f(1,0);       v3f(xC+tx, yC+txBombe/2,z);
          t2f(1,yFil01);  v3f(xC+tx, yUp,z);
          t2f(0,yFil01);  v3f(xC-tx, yUp,z);
        glEnd();
        if (Typ012)
        {
                int kSpr;
                if (Typ012==1)  kSpr=kAction %NbExpl;
                if (Typ012==2) {kSpr=kAction %(NbExpl*2-2);if (kSpr>=NbExpl) kSpr=2*NbExpl-2-kSpr;}
                gl.CarrezCST2Centre(xC,yUp, te,te, z,TexExpl[kSpr]);
        }
        gl.DisableSpr();glEnable(GL_DEPTH_TEST);
}
void TGLBombe::Load (string TexB, string TexC, string TexE, int NbExpL)
{
        for (int k=1; k<=NbExpL; k++) {
                string AS=TexE+XS.IntToStr(k)+".bmp";
        }
        NbExpl=NbExpL;
}
//**********************************************************
//***** 10 **** TUNNEL *************************************
//**********************************************************
#define TEXTURE_SPEED 0.02
#define A32 32
#define Tunnels(a,b) Tunnel[A32*(a)+(b)]
typedef struct {	float x,y,z;
                	float u, v;} VERTEX;
//*** Notice : VitesseConstante : TRUE, comme a y'a pas besoin de AngleManuel.
//*** Notice : DebutDeOnVire : 0 ou la date de dpart (en millisecondes, of course)
bool glTunnel (GLuint Tex,bool VitesseConstante,float AngleManuel,bool glClearAll,float tact,float DebutDeOnVire,float TempsPourVirer,bool FonduTunnel)//en quelle unit?
{
	float Angle=AngleManuel;
	if (DebutDeOnVire) {if (tact-DebutDeOnVire>TempsPourVirer) return(true);};
	glPushMatrix();//********** GL PUSH MATRIX !!!!!!!!!!!!!!!!!
        TGV GV;

	VERTEX Tunnel [A32*13]; 	float I,J;
	GLfloat C,J1,J2;

	if (glClearAll) glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);    // Clear The Screen And The Depth Buffer

	glMatrixMode(GL_PROJECTION);	glLoadIdentity();gluPerspective(45.0, 1, 1.0, 100.0);  // Do the perspective calculations. Last value = max clipping depth
	glMatrixMode(GL_MODELVIEW);     glLoadIdentity();glTranslatef(0.0,0.0,-4.2);
	if (VitesseConstante) {Angle=tact/14;}

	// setup tunnel coordinates
	for (I=0;I<13;I++) for (J=0;J<A32;J++)
        {
            Tunnels((int)I, (int)J).x =(3 - J/12)*cos(2*PI/12*I) + 2*sin((Angle+2*J)/29) + cos((Angle+2*J)/13) - 2*sin(Angle/29) - cos(Angle/13);
            Tunnels((int)I, (int)J).y =(3 - J/12)*sin(2*PI/12*I) + 2*cos((Angle+2*J)/33) + sin((Angle+2*J)/17) - 2*cos(Angle/33) - sin(Angle/17);
            Tunnels((int)I, (int)J).z =-J;
        };

	glTexture(Tex);
	if (FonduTunnel) glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);	//### On peut mettre GL_BLEND ou GL_MODULATE

	int jMax = (DebutDeOnVire ?  (float)(A32-1)*(   1  -  (float)(tact-DebutDeOnVire)/TempsPourVirer    )    :  A32-1);
	for (J=0;J<jMax;J++)
	{
		J1 =(float)  J  /A32 + Angle*TEXTURE_SPEED;        // precalculate texture v coords for speed
		J2 =(float)(J+1)/A32 + Angle*TEXTURE_SPEED;

		if (FonduTunnel)        // near the end of the tunnel, fade the effect away
		{	if (J > 14) C =1.0-(J-14)/18; else  C =1.0;
			glColor3f(C*GV.C[0], C*GV.C[1], C*GV.C[2]);
		}
		glBegin(GL_QUADS);
		for (I=0;I<12;I++)
			{glTexCoord2f((I-3)/12, J1); glVertex3f(Tunnels( (int)I,   (int)J ).x, Tunnels( (int)I,   (int)J ).y, Tunnels( (int)I,   (int)J ).z);
			 glTexCoord2f((I-2)/12, J1); glVertex3f(Tunnels((int)I+1,  (int)J ).x, Tunnels((int)I+1,  (int)J ).y, Tunnels((int)I+1,  (int)J ).z);
			 glTexCoord2f((I-2)/12, J2); glVertex3f(Tunnels((int)I+1, (int)J+1).x, Tunnels((int)I+1, (int)J+1).y, Tunnels((int)I+1, (int)J+1).z);
			 glTexCoord2f((I-3)/12, J2); glVertex3f(Tunnels( (int)I,  (int)J+1).x, Tunnels( (int)I,  (int)J+1).y, Tunnels( (int)I,  (int)J+1).z);}
		glEnd();
	}

	glPopMatrix();//********** GL POP MATRIX !!!!!!!!!!!!!!!!!
        GV.SetVars();
	return(false);
}
bool glTunnel01 (GLuint Tex,bool VitesseConstante,float AngleManuel,bool glClearAll,float tact,float PartieAff01                       ,bool FonduTunnel)
{
        if (PartieAff01==1) return (glTunnel(Tex,VitesseConstante,AngleManuel,glClearAll,tact,0,0,FonduTunnel));
                            return (glTunnel(Tex,VitesseConstante,AngleManuel,glClearAll,tact,tact-(1-PartieAff01)*1000 ,1000 ,FonduTunnel));
}
#undef Tunnels
//**********************************************************
//***** 9 **** CAMERA **************************************
//**********************************************************
//**********************************************************
int    KeyMove[NBKEYSCAM];          // 0=Avance  1=Recule 2=tourneGauche 3=tourneDroite 4=ShiftGauche 5=ShiftDroite 6=VolerUp 7=VolerDown 8=tOUI_Up 9=tOUI_Down 10=Avance3D 11=VolerUp
float DistMove[NBKEYSCAM];          // en distance par seconde
float SensiX,SensiY;                // pour Souris
void TRepere::Refresh() // NON(y) puis OUI(x) puis HOCHE(z) (c'est bien)
{
        if (IsCamera)   glMatrixMode(GL_PROJECTION);
        if (!IsCamera)  glLoadIdentity();
        if (IsCamera) { if (Scale*Sx!=1 || Scale*Sy!=1 || Scale*Sz!=1) glScalef(Scale*Sx,Scale*Sy,Scale*Sz); }
        if (!IsCamera)  glTranslated (x.a(),y.a(),z.a());
        glRotated( tetY.a()*360/(2*PI) , 0,                1,               0  );
        glRotated( tetX.a()*360/(2*PI) , cos(tetY.a()), 0, sin(tetY.a())       );
        glRotated( tetZ.a()*360/(2*PI) , 0,                0,               1  );
        if (IsCamera) glTranslated (x.a(),y.a(),z.a());
        if (!IsCamera) { if (Scale*Sx!=1 || Scale*Sy!=1 || Scale*Sz!=1) glScalef(Scale*Sx,Scale*Sy,Scale*Sz); }
        if (IsCamera) gl.MV();
}
//---------------------------------------------------
void DrawFleche( float tx, float x, float y, float z, float dx, float dy, float dz,
                           float r, float v, float b, float a, bool txABSOLUTE)
{
        glLineWidth(1.2);
        gl.ColorON(r,v,b);
        T3f Dir(dx,dy,dz);
        Dir.Normalize();
        Dir = Dir * tx;
        glBegin(GL_LINES);
          v3f(x,y,z);
          v3f(x+Dir.x, y+Dir.y, z+Dir.z);
        glEnd();
}
//---------------------------------------------------
void DrawCone(float tz, float r) // ce cne pointe vers les z ngatifs, et x,y,z est le centre du gd cercle
{
        glBegin(GL_TRIANGLE_FAN);
           v3f(0,0,tz);               // sommet
           const int NBC = 10;
           for (int k=0; k<=NBC; k++)
           {
                float theta = 2*3.14159265/NBC*k;
                v3f(cos(theta)*r, sin(theta)*r, 0);
           }
        glEnd();
}
//---------------------------------------------------
#define glpupo glPopMatrix();glPushMatrix()
void DrawRepereGalilee(float tx)
{
        glPushMatrix();
               DrawFleche(tx, 0,0,0, 1,0,0, 1,0,0,1, true);glpupo;glTranslatef(tx,0,0);glRotated(90,0,1,0); DrawCone(tx*0.35, tx*0.10);
        glpupo;DrawFleche(tx, 0,0,0, 0,1,0, 0,1,0,1, true);glpupo;glTranslatef(0,tx,0);glRotated(90,-1,0,0);DrawCone(tx*0.35, tx*0.10);
        glpupo;DrawFleche(tx, 0,0,0, 0,0,1, 0,0,1,1, true);glpupo;                     glTranslatef(0,0,tx);DrawCone(tx*0.35, tx*0.10);
        glPopMatrix();
}
void TRepere::DrawRepere()
{
        TexEnv.Get();TexEnv.SetModeLine();
        glPushMatrix();glId();Refresh();

        DrawRepereGalilee(0.4);

        glPopMatrix();
        TexEnv.Set();
}
//-------------------------------------------
void TRepere::DrawReperexyz(T3f * xyz)         // Dessine la b.o.n. xyz en R.GetT3f
{
        TexEnv.Get();TexEnv.SetModeLine();glLineWidth(5);
        glPushMatrix();glId();

        glTranslatef(x.a(), y.a(), z.a());
        double M[16];XYZ.BuildTransfo(xyz, M);
        glMultMatrixd(M);

        DrawRepereGalilee(0.4);

        glPopMatrix();
        TexEnv.Set();
}
//-------------------------------------------
void DrawRepereOrtho(T3f C, T3f * xyz)
{
        gl.Line(C.x,C.y,C.z, C.x+xyz[0].x, C.y+xyz[0].y, C.z+xyz[0].z,1,0,0);
        gl.Line(C.x,C.y,C.z, C.x+xyz[1].x, C.y+xyz[1].y, C.z+xyz[1].z,0,1,0);
        gl.Line(C.x,C.y,C.z, C.x+xyz[2].x, C.y+xyz[2].y, C.z+xyz[2].z,0,0,1);
}
//-------------------------------------------
//MATRIX(  [ [cos(tetY) , -sin(tetX)*sin(tetY) , -cos(tetX)*sin(tetY)  ],
//           [0         ,  cos(tetX)           , -sin(tetX)            ],
//           [sin(tetY) ,  sin(tetX)*cos(tetY) ,  cos(tetX)*cos(tetY)] ] )
// voici ce que Maple en pense
void TRepere::Avance  (float depl, float duree){z=z.fin+depl*cos(tetY.a());z.duree=duree;  x=x.fin-depl*sin(tetY.a());x.duree=duree;}
void TRepere::Avance3D(float depl, float duree) // Axe OZ
{
        x=x.fin-depl*sin(tetY.a())*cos(tetX.a());x.duree=duree;
        y=y.fin+depl*              sin(tetX.a());y.duree=duree;
        z=z.fin+depl*cos(tetY.a())*cos(tetX.a());z.duree=duree;
}
void TRepere::Vole3D(float depl, float duree) // Axe OY
{
    x=x.fin-  depl*sin(tetX.a())*sin(tetY.a());  x.duree=duree;
    y=y.fin-  depl*cos(tetX.a());                y.duree=duree;
    z=z.fin+  depl*sin(tetX.a())*cos(tetY.a());  z.duree=duree;
}
void TRepere::Shift(float depl, float duree) // Axe OX
{
    //    x=x.fin+depl*sin(tetY.a()-PI/2);x.duree=duree;
    //    z=z.fin-depl*cos(tetY.a()-PI/2);z.duree=duree;
        x=x.fin+depl*cos(tetY.a());x.duree=duree;
        z=z.fin+depl*sin(tetY.a());z.duree=duree;
}
//-------------------------------------------
void TRepere::Avance3D2 (float depl, float duree, T3f *xyz) {T3f c(x.a(),y.a(),z.a()); c=c+xyz[2]*depl; x=c.x; y=c.y; z=c.z; SetAllDuree(duree);}  // Axe OZ
void TRepere::Vole3D2   (float depl, float duree, T3f *xyz) {T3f c(x.a(),y.a(),z.a()); c=c+xyz[1]*depl; x=c.x; y=c.y; z=c.z; SetAllDuree(duree);}  // Axe OY
void TRepere::Shift2    (float depl, float duree, T3f *xyz) {T3f c(x.a(),y.a(),z.a()); c=c+xyz[0]*depl; x=c.x; y=c.y; z=c.z; SetAllDuree(duree);}  // Axe OX
//-------------------------------------------
TRepere::TRepere(bool IsCam, float DistPerSec)
{       //--- 1 --- Coord camra
        x=0;y=0;z=0; tetZ=0;tetY=0;tetX=0;
        IsCamera=IsCam;
        Scale=Sx=Sy=Sz=1;
        AffRepere=false;

        //--- 2 --- Clavier GLOBAL
        KeyMove[0]=K_Z;        KeyMove[1]=K_S;        KeyMove[2]=K_Q;
        KeyMove[3]=K_D;
        KeyMove[5]=K_A;         // 4 / 5
        KeyMove[4]=K_E;
        KeyMove[7]=K_ESPACE;    // 6 / 7
        KeyMove[6]=K_W;
        KeyMove[8]=K_PAGEUP;    // 8 / 9
        KeyMove[9]=K_PAGEDOWN;
        KeyMove[10]=K_2;        KeyMove[11]=0;        KeyMove[12]=K_DEBUT;        KeyMove[13]=K_FIN;
        SetDistMove(DistPerSec , 2*3.14);
        //--- 3 --- Souris
        SensiX=1;   SensiY=1;
}
//-------------------------------------------
void TRepere::MoveCameraSouris (float dx, float dy)
{
        tetY.Fixe(tetY.a() + dx*SensiX*0.004);
        tetX.Fixe(tetX.a() + dy*SensiY*0.004);
}
void TRepere::MoveCameraSouris () {
    if (!Souris.MiddleEnfonce()) return;
    float inv=(IsCamera?1:-1);  // inv=1;
    if (Souris.x!=Souris.oldx || Souris.y!=Souris.oldy)
    {
        MoveCameraSouris( (Souris.x-Souris.oldx)*0.7        , (Souris.y-Souris.oldy)*0.7*inv );
    }
}
void TRepere::MoveCameraKTime ()
{       int * K_Time = KTime; float dt=K.dtime;
        #define KTMove(a) if (K_Time[KeyMove[a]]>0)
        KTMove( 0)  Avance3D(DistMove[0]*dt ,0);             /* 0=Avance3D */  // Z
        KTMove( 1)  Avance3D(DistMove[1]*dt ,0);             /* 1=Recule */    // S
        KTMove( 2)  tetY.Fixe(tetY.a()+DistMove[2]*dt*0.3);  /* 2=tGauche */   // Q
        KTMove( 3)  tetY.Fixe(tetY.a()+DistMove[3]*dt*0.3);  /* 3=tDroite */   // D
        KTMove( 4)  Shift (DistMove[4]*dt*0.7 ,0);           /* 4=ShiftG */    // A
        KTMove( 5)  Shift (DistMove[5]*dt*0.7 ,0);           /* 5=ShiftD */    // E
        KTMove( 6)  Vole3D(DistMove[6]*dt,0);                /* 6=VolerUp */   // SPACE
        KTMove( 7)  Vole3D(DistMove[7]*dt,0);                /* 7=VolerDown */ // W
//        KTMove( 8)  tetX.Fixe ( tetX.a()+DistMove[8]*dt);    /* 8=tOUI_Up */   // PAGE_UP
//        KTMove( 9)  tetX.Fixe ( tetX.a()+DistMove[9]*dt);    /* 9=tOUI_Down */ // PAGE_DOWN
        KTMove(10)  Avance(DistMove[10]*dt ,0);              /* 10=Avance */   // 2
        KTMove(11)  y = y.a()+DistMove[11]*dt;
        KTMove(12)  tetY.Fixe( tetY.a()+DistMove[8]*dt);     /* 12=tNON_Up */   // DEBUT
        KTMove(13)  tetY.Fixe( tetY.a()+DistMove[9]*dt);     /* 13=tNON_Down */ // FIN
}
void TRepere::SetDistMove(float dPerSec, float RotPerSec)
{       DistMove[0]=DistMove[5]=DistMove[7]=DistMove[10]  =  dPerSec;
        DistMove[1]=DistMove[4]=DistMove[6]=DistMove[11]  = -dPerSec;
        DistMove[2]=-RotPerSec;         DistMove[8]= RotPerSec*0.5;
        DistMove[3]= RotPerSec;         DistMove[9]=-RotPerSec*0.5;
}
string TRepere::StrCam()      {return("x="   +XS.FloatToStr2Ch(x.a())    +  " y="   +XS.FloatToStr2Ch(y.a())     +  " z="   +XS.FloatToStr2Ch(z.a())       );}
string TRepere::StrCamTet()   {return("tetX="+XS.FloatToStr2Ch(tetX.a()) +  " tetY="+XS.FloatToStr2Ch(tetY.a())  +  " tetZ="+XS.FloatToStr2Ch(tetZ.a())       );}
string TRepere::StrCamALL()   {return(StrCam() + " " + StrCamTet());}
string TRepere::StrCam2()     {return(XS.FloatToStr2Ch(x.a()   ) +  " " + XS.FloatToStr2Ch(y.a())    +  " "  + XS.FloatToStr2Ch(z.a())     );}
string TRepere::StrCamTet2()  {return(XS.FloatToStr2Ch(tetX.a()) +  " " + XS.FloatToStr2Ch(tetY.a()) +  " "  + XS.FloatToStr2Ch(tetZ.a())  );}
string TRepere::StrCamALL2()  {return(StrCam2() + " " + StrCamTet2());}
string TRepere::StrCamxS()    {return(StrCam() + "   (S x y z)=" + XS.FloatToStr2Ch(Scale)+" "+XS.T3fToStr2Ch(&Sx));}

void TRepere::StrCamxSRECIPR(string s)
{
        vfloat vf; XS.StrTovf(s,vf);
        SetPosInstant(vf[0],vf[1],vf[2]);
        Scale=vf[3];
        SetScale(vf[4],vf[5],vf[6]);
}
//-------------------------------------------
void TRepere::MoveCameraKTime2 (T3f *xyz)
{
       int * K_Time = KTime; float dt=K.dtime;
       KTMove( 0)  Avance3D2(DistMove[0]*dt, 0,xyz);             /* 0=Avance3D */  // Z
       KTMove( 1)  Avance3D2(DistMove[1]*dt, 0,xyz);             /* 1=Recule */    // S
       KTMove( 4)  Shift2   (DistMove[4]*dt*0.7 ,0, xyz);        /* 4=ShiftG */    // A
       KTMove( 5)  Shift2   (DistMove[5]*dt*0.7 ,0, xyz);        /* 5=ShiftD */    // E
       KTMove( 6)  Vole3D2  (DistMove[6]*dt,0, xyz);             /* 6=VolerUp */   // SPACE
       KTMove( 7)  Vole3D2  (DistMove[7]*dt,0, xyz);             /* 7=VolerDown */ // W
}
//-------------------------------------------
void TRepere::MoveCameraSouris2 (T3f *xyz)
{
        float dt=K.dtime;
        //--- 1 --- Molette = loignement
        if (Souris.zDelta) { Avance3D2(DistMove[0]*dt*(Souris.zDelta/WHEEL_DELTA)*1.4, 0, xyz); Souris.zDelta=0; }
}
//-------------------------------------------
//-------------------------------------------
//-------------------------------------------
//-------------------------------------------
/*
                                                   B
                                                   A C
                                                D

                                          CAM
*/
#define DW2Pt(b,a) a.x=b[0]; a.y=b[1]; a.z=b[2]
void TRepere::GetRepereOrtho(T3f * xyz)   // renvoie un repre xyz norm, sur l'axe (Origine, Point de fuite)
{
        GLint viewport[4];      // (x0,y0, width, height)
        GLdouble mvmatrix[16], projmatrix[16];
        glGetIntegerv (GL_VIEWPORT, viewport);        glGetDoublev  (GL_MODELVIEW_MATRIX ,   mvmatrix);        glGetDoublev  (GL_PROJECTION_MATRIX, projmatrix);

        int yEcr = viewport[0] + viewport[3];   // coord HAUT
        int xEcr = viewport[1] + viewport[2];   // coord DROITE
        int xE2  = viewport[0] + xEcr / 2;      // coord GAUCHE (centre cran)
        int yE2  = viewport[1] + yEcr / 2;      // coord BAS    (centre cran)

        double dw[3];
        T3f A,B,C,D;
        gluUnProject  (xE2   , yE2   , 1, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); DW2Pt(dw,A);  // le point A
        gluUnProject  (xE2   , yEcr  , 1, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); DW2Pt(dw,B);  // le point B
        gluUnProject  (xEcr  , yE2   , 1, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); DW2Pt(dw,C);  // le point C
        gluUnProject  (xE2   , yE2   , 0, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); DW2Pt(dw,D);  // le point D
        // ARGHHHHH !!!!!!! je comprends toujours pas !!!!!!!!!! il faut passer en ngatif des coordonnes ou pas ???

        xyz[0] = C-A;  // Vecteur x
        xyz[1] = B-A;  // Vecteur y
        xyz[2] = D-A;  // Vecteur z
        xyz[0].Normalize();
        xyz[1].Normalize();
        xyz[2].Normalize();
}
//-------------------------------------------
void TRepere::Conv2D3D (float xIn, float yIn, float zIn01,  T3f &PtOut) // xIn et yIn en pixels Souris
{
        GLint viewport[4];                            GLdouble mvmatrix[16], projmatrix[16];
        glGetIntegerv (GL_VIEWPORT, viewport);        glGetDoublev  (GL_MODELVIEW_MATRIX ,   mvmatrix);        glGetDoublev  (GL_PROJECTION_MATRIX, projmatrix);
//        int yEcr = viewport[3]; // viewport[3] est la hauteur de la fentre en pixels
//        int xEcr = viewport[2]; // pas vrifi encore
        double dw[3];
        gluUnProject  ( xIn, yIn, zIn01, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); DW2Pt(dw,PtOut);
}
/*
//-------------------------------------------
void TRepere::GetCenterFrustum  (T3f &cf)   // renvoie le point (0, 0 ,0.5) de la frustum
{
        GLint viewport[4];                            GLdouble mvmatrix[16], projmatrix[16];
        glGetIntegerv (GL_VIEWPORT, viewport);        glGetDoublev  (GL_MODELVIEW_MATRIX ,   mvmatrix);        glGetDoublev  (GL_PROJECTION_MATRIX, projmatrix);
        int yEcr = viewport[3]; // viewport[3] est la hauteur de la fentre en pixels
        int xEcr = viewport[2]; // pas vrifi encore
        double dw[3];
        gluUnProject  (xEcr/2,yEcr/2, 0.1, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); DW2Pt(dw,cf);
}
*/
void TRepere::GetCenterFrustum  (T3f &cf)   // renvoie le point (0, 0 ,0.5) de la frustum
{
        GLint viewport[4];  glGetIntegerv (GL_VIEWPORT, viewport);
        int yEcr = viewport[3];
        int xEcr = viewport[2];
        Conv2D3D(xEcr/2, yEcr/2, 0.1, cf);
}
//-------------------------------------------
//-------------------------------------------
//  C = Centre Camera
//  P = Point cliqu  l'infini
//  M = Point cherch = Plan INTER (CP) = (1-t)C + tP
//
//  O et xyz = Plan affine sur lequel on projette
//  L'quation (1-t)C + tP = projet de M sur Plan donne t(CP.z)z = (CO.z).z o (x,y,z)=b.o.n.vectorielle du Plan
//
//       Le code ci-dessous calcule (normalement) l'intersection de CP avec le plan (O + xyz)
//
/*        T3f CAM(x.a(),y.a(),z.a());
        CAM = CAM*(-1);
        T3f P;
        Conv2D3D( xIN,yIN,1, P);

        T3f Dir = (P-CAM); Dir.Normalize();
//        float t = (O_IN-CAM).Norme();
        float t = (O_IN-CAM).Scal(xyzIN[2]) / (Dir).Scal(xyzIN[2]);
        M_Out = CAM + Dir*t;
*/

void TRepere::Souris2Plan (float xIN, float yIN, T3f * xyzIN, T3f O_IN, T3f &M_Out)
{
        T3f P;  Conv2D3D( xIN,yIN,1, P); // Le point  l'infini sur lequel on a cliqu
        XYZ.ProjOrtho(P , O_IN,xyzIN, M_Out);
}
//-------------------------------------------
void TRepere::SaveFile(TFilew &F)
{
        F.Wri_float(x   .fin);        F.Wri_float(y   .fin);        F.Wri_float(z   .fin);
        F.Wri_float(tetX.fin);        F.Wri_float(tetY.fin);        F.Wri_float(tetZ.fin);
        F.Wri_bool(IsCamera);         F.Wri_bool(AffRepere);
        F.Wri_float(Scale);
        F.Wri_float(Sx);              F.Wri_float(Sy);              F.Wri_float(Sz);
}
//-------------------------------------------
void TRepere::LoadFile(TFilerb &F)
{
        F.Read_float(x   .fin);        F.Read_float(y   .fin);        F.Read_float(z   .fin);
        F.Read_float(tetX.fin);        F.Read_float(tetY.fin);        F.Read_float(tetZ.fin);
        F.Read_bool(IsCamera);         F.Read_bool(AffRepere);
        F.Read_float(Scale);
        F.Read_float(Sx);              F.Read_float(Sy);              F.Read_float(Sz);
}
//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
//******************************************************************************************************************************
void TCamera::InitProjection(float Angle45,float RatioWidthHeight, float zNear001, float zFar100)
{       glMatrixMode(GL_PROJECTION);glLoadIdentity();
        gluPerspective( 45.0, RatioWidthHeight, zNear001, zFar100);
        AngleOuv=Angle45; Near=zNear001; Far=zFar100;
        gl.MV();
}
//-------------------------------------------
/*
                       45
                       76
                   01
                   32

              C
*/
#define GUProj(xx,yy,zz,kk) gluUnProject  (xx,yy,zz, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); DW2Pt(dw,FF[kk]);
void TCamera::Frustum_Calc8Pts(T3f * FF)
{
        GLint viewport[4];                            GLdouble mvmatrix[16], projmatrix[16];
        glGetIntegerv (GL_VIEWPORT, viewport);        glGetDoublev  (GL_MODELVIEW_MATRIX ,   mvmatrix);        glGetDoublev  (GL_PROJECTION_MATRIX, projmatrix);
        int yEcr = viewport[3]; // viewport[3] est la hauteur de la fentre en pixels
        int xEcr = viewport[2];
        double dw[3];
        GUProj(   0,0   ,0,0);        GUProj(xEcr,0   ,0,1);        GUProj(xEcr,yEcr,0,2);        GUProj(   0,yEcr,0,3);
        GUProj(   0,0   ,1,4);        GUProj(xEcr,0   ,1,5);        GUProj(xEcr,yEcr,1,6);        GUProj(   0,yEcr,1,7);
}
//-------------------------------------------
void TCamera::Frustum_Calc(T3f * Frustum) // Frustum a 5 cases : 4 points FAR + point CAMERA
{
        GLint viewport[4];                            GLdouble mvmatrix[16], projmatrix[16];
        glGetIntegerv (GL_VIEWPORT, viewport);        glGetDoublev  (GL_MODELVIEW_MATRIX ,   mvmatrix);        glGetDoublev  (GL_PROJECTION_MATRIX, projmatrix);
        int yEcr = viewport[3]; // viewport[3] est la hauteur de la fentre en pixels
        int xEcr = viewport[2]; // pas vrifi encore

        double dw[3];
        gluUnProject  (0   , 0     , 1, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); Frustum[0].x=dw[0]; Frustum[0].y=dw[1]; Frustum[0].z=dw[2];
        gluUnProject  (xEcr, 0     , 1, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); Frustum[1].x=dw[0]; Frustum[1].y=dw[1]; Frustum[1].z=dw[2];
        gluUnProject  (xEcr, yEcr  , 1, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); Frustum[2].x=dw[0]; Frustum[2].y=dw[1]; Frustum[2].z=dw[2];
        gluUnProject  (0   , yEcr  , 1, mvmatrix, projmatrix, viewport, &dw[0], &dw[1], &dw[2]); Frustum[3].x=dw[0]; Frustum[3].y=dw[1]; Frustum[3].z=dw[2];
        Frustum[4].x = -this->x.a();
        Frustum[4].y = -this->y.a();
        Frustum[4].z = -this->z.a(); // ARGHHHHH !!!!!!! je comprends toujours pas !!!!!!!!!!
}

void TXYZ::BuildTransfo(T3f * xyzIN, double M[16])
{
        M[0]=xyzIN[0].x;        M[4]=xyzIN[1].x;        M[ 8]=xyzIN[2].x;        M[12]=0;
        M[1]=xyzIN[0].y;        M[5]=xyzIN[1].y;        M[ 9]=xyzIN[2].y;        M[13]=0;
        M[2]=xyzIN[0].z;        M[6]=xyzIN[1].z;        M[10]=xyzIN[2].z;        M[14]=0;
        M[3]=0;                 M[7]=0;                 M[11]=0;                 M[15]=1;
}

void TXYZ::ProjOrtho   (T3f &A_IN,   T3f &O_IN, T3f*xyz_IN,  T3f &H_OUT) // Projection sur Oxy de Oxyz
{
        T3f OA = A_IN - O_IN;
        T3f OH = xyz_IN[0] * OA.Scal(xyz_IN[0]) +
                 xyz_IN[1] * OA.Scal(xyz_IN[1]);
        H_OUT = O_IN + OH;
}

//**************************************************************************
//**************************************************************************
void TColorX::TColorToRGBf(int Color, float* RVB)
{      int R = (Color    ) %256;  RVB[0] = (float)(R)/255.0;
           R = (Color>> 8) %256;  RVB[1] = (float)(R)/255.0;
           R = (Color>>16) %256;  RVB[2] = (float)(R)/255.0;
}
void TColorX::RGBfToTColor(float* RVB, int* Color)
{
        int R=RVB[0]*255;
        int V=RVB[1]*255;
        int B=RVB[2]*255;
        *Color = R + V*256 + B*65536;
}

//**********************************************************
//***** 11 *** TSkyBox  ************************************
//**********************************************************

// SysFile = 0   : Load ("SkyBox\\"      , "3" , 0 );
// SysFile = 1   : Load ("SkyBoxes2\\"   , ""  , 1 ); // Compltion de 1  6.    CodeNULL=030001
void TSkyBox::Load(string NomRep, string NomFile, int SysFile,char *CodeNULL)
{
}

#define DOITTT  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);glTexParameteri	(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);glShadeModel	(GL_FLAT)
#define RTSB(a) glMatrixMode(GL_TEXTURE);glLoadIdentity();glRotatef(90*Rot[a],0,0,1);glMatrixMode(GL_MODELVIEW);
void TSkyBox::Draw (float TT,float RotRAD)
{
    glMatrixMode(GL_MODELVIEW);glPushMatrix();
    glScalef(-1,-1,-1); // CHUUUTT !!! (normalement c'est les textures de SkyBox qui sont fausses, pas le reste qui est trop bien)

    glRotatef(RotRAD*360/6.28,0,1,0);  // b.o.n.d. ( loin = z ngatifs )
    float x1,y1,z1; x1=y1=z1=-TT;
    float x2,y2,z2; x2=y2=z2= TT;
    uint * PtTex=Tex;

//  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP); //**** EXTREMEMENT IMPRESSIONNANT !!!!!!!!!!!!!!!!!!
//  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP); //**** Sans a on voit les artes.
  glDisable(GL_DEPTH_TEST);glDepthMask(GL_FALSE);
  glTexture(PtTex[2]);DOITTT;RTSB(2);  glBegin(GL_QUADS);t2f(1,0);v3f(x1,y1,z1);t2f(0,0);v3f(x2,y1,z1);t2f(0,1);v3f(x2,y2,z1);t2f(1,1);v3f(x1,y2,z1);glEnd();
  glTexture(PtTex[5]);DOITTT;RTSB(5);  glBegin(GL_QUADS);t2f(1,0);v3f(x1,y2,z1);t2f(0,0);v3f(x2,y2,z1);t2f(0,1);v3f(x2,y2,z2);t2f(1,1);v3f(x1,y2,z2);glEnd();
  glTexture(PtTex[3]);DOITTT;RTSB(3);  glBegin(GL_QUADS);t2f(1,1);v3f(x1,y2,z2);t2f(0,1);v3f(x1,y2,z1);t2f(0,0);v3f(x1,y1,z1);t2f(1,0);v3f(x1,y1,z2);glEnd();
  glTexture(PtTex[4]);DOITTT;RTSB(4);  glBegin(GL_QUADS);t2f(0,1);v3f(x2,y2,z2);t2f(1,1);v3f(x2,y2,z1);t2f(1,0);v3f(x2,y1,z1);t2f(0,0);v3f(x2,y1,z2);glEnd();
  glTexture(PtTex[1]);DOITTT;RTSB(1);  glBegin(GL_QUADS);t2f(1,1);v3f(x1,y1,z1);t2f(0,1);v3f(x2,y1,z1);t2f(0,0);v3f(x2,y1,z2);t2f(1,0);v3f(x1,y1,z2);glEnd();
  glTexture(PtTex[0]);DOITTT;RTSB(0);  glBegin(GL_QUADS);t2f(0,0);v3f(x1,y1,z2);t2f(1,0);v3f(x2,y1,z2);t2f(1,1);v3f(x2,y2,z2);t2f(0,1);v3f(x1,y2,z2);glEnd();
  glEnable(GL_DEPTH_TEST);glDepthMask(GL_TRUE);
  glPopMatrix();
}
//**********************************************************
//***** 12 *** TFonte  *************************************
//**********************************************************
TTexEnv TexEnv;
TFonte  Fontes;
float a_Shadow=1;
float TFonteLoc::Wri(float x, float y, float z,float tx,float ty,string Txt,float kFont)
{       if ((TxBMP==0)||(TyBMP==0)) return(0);
        TTexEnv TEnv; TEnv.Get();

        glEnable(GL_TEXTURE_2D);
	glTexture(Tex);
	glMatrixMode(GL_TEXTURE);	glPushMatrix();	glLoadIdentity();	gl.SetTexture(0,1/(float)TyBMP,1/(float)TxBMP,0);
	glMatrixMode(GL_MODELVIEW);
        glEnable(GL_ALPHA_TEST);   glAlphaFunc(GL_GREATER, 0.0f);
        glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
        gl.EnableBlend();

        float xx=x;
        float yy;
        int kC=Fontes.kConf(kFont); TConfigFont * CF=&(this->Conf[kC]);        bool Col=(CF->Cu!=0)||(CF->Cd!=0);        if (Col) glShadeModel(GL_SMOOTH);
	glBegin(GL_QUADS);
        float *CA=TEnv.CurrentColor;
        float CShadow[4]; memcpy(CShadow,CA,sizeof(CShadow)); CShadow[3]=a_Shadow;glColor4fv(CShadow);

        for (uint k=0; k<Txt.length(); k++)
        {       unsigned char ch=Txt[k]; // ATTENTION AUX string. Y'a le +1 avec les Ansi et pas avec les string
                TLettre * L=&Let[ch];
                if (ch==' ')  {xx+=tx*0.3; continue;}       if (L->x1==0)     continue;
                float txc=tx*(float(L->x2 - L->x1)/(float)NbPixMaxX);
                float tyc=ty*(float(L->yd - L->yu)/(float)NbPixMaxY);
                if (tx==-1) {txc = L->x2-L->x1; tyc=L->yd-L->yu;}

                yy=y - (float)(L->yd - L->ya)/((float)L->yd - L->yu)*tyc;
                if (Col) glColor3f(CF->rd()*CA[0],CF->gd()*CA[1],CF->bd()*CA[2]);  t2f(L->x1,L->yd);  v3f(xx      ,yy      ,z);
                if (Col) glColor3f(CF->ru()*CA[0],CF->gu()*CA[1],CF->bu()*CA[2]);  t2f(L->x1,L->yu);  v3f(xx      ,yy+ tyc ,z);
                if (Col) glColor3f(CF->ru()*CA[0],CF->gu()*CA[1],CF->bu()*CA[2]);  t2f(L->x2,L->yu);  v3f(xx+ txc ,yy+ tyc ,z);
                if (Col) glColor3f(CF->rd()*CA[0],CF->gd()*CA[1],CF->bd()*CA[2]);  t2f(L->x2,L->yd);  v3f(xx+ txc ,yy      ,z);


                if (ty==-1) xx+=L->xdec;
                       else xx+=txc+tx*0.07;

        }
	glEnd();
        glDisable(GL_ALPHA_TEST);
        TEnv.Set();
	glMatrixMode(GL_TEXTURE);	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
        return(xx-x);
}
//------------------------------------------
float TFonteLoc::WriBlitting(float x, float y, string Txt)
{
        glPushMatrix();
        glMatrixMode(GL_PROJECTION);    glPushMatrix();
        glMatrixMode(GL_TEXTURE);	glPushMatrix();	glLoadIdentity();	gl.SetTexture(0,1/(float)TyBMP,1/(float)TxBMP,0);
        gl.SetScreen2D(F.Width,F.Height,false );
        TexEnv.Get();

        int xx=x;
        int yy;
        int tx = 20;

        glEnable(GL_TEXTURE_2D);
        glTexture(Tex);
        glEnable(GL_ALPHA_TEST);   glAlphaFunc(GL_GREATER, 0.0f);
        glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
        gl.ColorOFF();
        gl.EnableBlend();

	glBegin(GL_QUADS);

        for (uint k=0; k<Txt.length(); k++)
        {       unsigned char ch  = Txt[k];
                TLettre *      L  = &Let[ch];
                if (ch==' ')  {xx+=tx*0.3; continue;}       if (L->x1==0)     continue;
                float txc = L->x2 - L->x1;
                float tyc = L->yd - L->yu;

                yy = y - (L->yd - L->ya);
                t2f(L->x1,L->yd+1);  v2f(xx      ,yy     );
                t2f(L->x1,L->yu);  v2f(xx      ,yy+ tyc);
                t2f(L->x2,L->yu);  v2f(xx+ txc ,yy+ tyc);
                t2f(L->x2,L->yd+1);  v2f(xx+ txc ,yy     );

                xx += txc + tx/10+1;
        }
	glEnd();

        glMatrixMode(GL_TEXTURE); glPopMatrix();
        glMatrixMode(GL_PROJECTION); glPopMatrix();
        glMatrixMode(GL_MODELVIEW);  glPopMatrix(); TexEnv.Set();
        return(xx-x);
}
//------------------------------------------
void TFonteLoc::WriShadow(float x, float y, float z,float tx,float ty,string Txt,float kFont, float alpha_shadow01, float decx1, float decy1)
{       a_Shadow=1;                     Wri(x              ,y              ,z,tx,ty,Txt,kFont);
        a_Shadow=alpha_shadow01;        Wri(x+decx1*tx*0.1 ,y+decy1*ty*0.1 ,z,tx,ty,Txt,kFont);

        a_Shadow=1;
}
//------------------------------------------
float TFonteLoc::WriCentre(float x, float y, float z,float tx,float ty,string Txt,float kFont)
{
        float TxTxt=TxWri(tx,Txt);
        return( Wri(x-TxTxt/2, y, z, tx, ty, Txt,kFont) );
}
//------------------------------------------
float TFonteLoc::TxWri(float tx, string Txt)
{
        float xx=0;
        for (uint k=0; k<Txt.length(); k++)
        {       unsigned char ch=Txt[k];
                TLettre * L=&Let[ch];
                if (ch==' ')  {xx+=tx*0.3; continue;}       if (L->x1==0)     continue;
                float txc=tx*(float(L->x2 - L->x1)/(float)NbPixMaxX);
                xx+=txc+tx*0.07;
        }
        return(xx);
}
//------------------------------------------
TXLoader XLoader;

void TXLoader::Reverse     (uchar* &PtIma, int tx,int ty, int NbCh)
{       uchar * pr=(uchar *)malloc(tx*ty*NbCh);
        for (int ky=0; ky<ty; ky++) memcpy ( &pr[ tx*ky*NbCh ] , &PtIma[ tx*(ty-ky-1)*NbCh ], tx*NbCh);
        free(PtIma);PtIma=pr;
}

void TXLoader::LoadBMP(string Filename,uint * IdxTexture)
{
    if (!Files.Exists(Filename)) glSortirProprement(Filename);
	unsigned char * PtIma;
	int tx,ty;
	XLoader.LoadBMP ( Filename,PtIma,tx,ty,3 );
	glGenTextures(1, IdxTexture);
	glBindTexture(GL_TEXTURE_2D,*IdxTexture);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D	(GL_TEXTURE_2D, 0, GL_RGB8,tx,ty,  0,GL_RGB, GL_UNSIGNED_BYTE,PtIma);
	free(PtIma);
}

void TXLoader::LoadBMPSpr (string Filename,uint * IdxTexture)
{
        if (!Files.Exists(Filename)) glSortirProprement(Filename);
	unsigned char * PtIma, * PtIma4, *PtActSrc, *PtActDest;
	int tx,ty,k;
	unsigned char Zero;
	XLoader.LoadBMP ( Filename,PtIma,tx,ty,3 );

	//*** Transformation
	PtIma4=(uchar*)malloc(tx*ty*4);
	PtActSrc =PtIma;
	PtActDest=PtIma4;
	for (k=0;k<tx*ty;k++)
	{
		Zero = 0; if (PtActSrc[0] || PtActSrc[1] || PtActSrc[2]) Zero=255;
		*PtActDest++=*PtActSrc++;//Rouge
		*PtActDest++=*PtActSrc++;//Bleu
		*PtActDest++=*PtActSrc++;//Vert
		*PtActDest++=Zero;//Transparence : 0 ou 255. C'est le seul truc qui change par rapport  glLoadBMPSpr
	}

	glGenTextures(1, IdxTexture);
	glBindTexture(GL_TEXTURE_2D,*IdxTexture);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D	(GL_TEXTURE_2D, 0, GL_RGBA8,tx,ty,  0,GL_RGBA, GL_UNSIGNED_BYTE,PtIma4);
	free(PtIma );	free(PtIma4);
}

void TXLoader::LoadTxTyBMP (string NomFich,int &Tx,int &Ty)
{       if (!Files.Exists(NomFich)) {glSortirProprement (NomFich);}
        FILE * fptr;
        uchar Buff[54];
        fptr=fopen (NomFich.c_str(),"rb");
        fread (&(Buff[0]),54,1,fptr);
        Tx	=Buff[18]+256*Buff[19]+65536*Buff[20]+256*65536*Buff[21];
        Ty 	=Buff[22]+256*Buff[23]+65536*Buff[24]+256*65536*Buff[25];
        fclose(fptr);
}
void TXLoader::FlipRB(void* buffer,int NbPixels,int NbCh)				// Flips The Red And Blue Bytes
{
    uchar * buf=(uchar*)buffer;
    uchar tmp;
    for (int k=0; k<NbPixels; k++)
    {
        tmp=*buf;
        *buf=buf[2];
        buf[2]=tmp;
        buf+=NbCh;
    }
}
void TXLoader::LoadBMPAlpha (string Filename,uint * IdxTexture)
{
        if (!Files.Exists(Filename)) glSortirProprement(Filename);
	unsigned char * PtIma, * PtIma4, *PtActSrc, *PtActDest;
	int tx,ty,k;
	unsigned char Zero;
	XLoader.LoadBMP ( Filename,PtIma,tx,ty,3 );

	//*** Transformation
	PtIma4=(uchar*)malloc(tx*ty*4);
	PtActSrc =PtIma;
	PtActDest=PtIma4;
	for (k=0;k<tx*ty;k++)
	{
		Zero = *PtActSrc; if (PtActSrc[1]>=Zero) Zero=PtActSrc[1]; if (PtActSrc[2]>=Zero) Zero=PtActSrc[2];
		*PtActDest++=*PtActSrc++;//Rouge
		*PtActDest++=*PtActSrc++;//Bleu
		*PtActDest++=*PtActSrc++;//Vert
		*PtActDest++=Zero;//Transparence : c'est le max des 3 coord. C'est le seul truc qui change par rapport  glLoadBMPSpr
	}

	glGenTextures(1, IdxTexture);
	glBindTexture(GL_TEXTURE_2D,*IdxTexture);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D	(GL_TEXTURE_2D, 0, GL_RGBA8,tx,ty,  0,GL_RGBA, GL_UNSIGNED_BYTE,PtIma4);
	free(PtIma );	free(PtIma4);
}
//*****************************************************************************
void TXLoader::LoadBMP (string NomFich,uchar* &PtIma/*TO BE MALLOCED!!!!*/,int &Tx,int &Ty,int NbCh)
{
        if (!Files.Exists(NomFich)) {glSortirProprement (NomFich);}

        FILE * fptr;
        fpos_t PosAct;
        fptr=fopen (NomFich.c_str(),"rb");
        unsigned char Buff[54];
        fgetpos(fptr,&PosAct);
        fread(&(Buff[0]),54,1,fptr);
        fgetpos(fptr,&PosAct);

        Tx	=Buff[18]+256*Buff[19]+65536*Buff[20]+256*65536*Buff[21];
        Ty 	=Buff[22]+256*Buff[23]+65536*Buff[24]+256*65536*Buff[25];
        int SizeImage=Tx * Ty *3; if (SizeImage==0) {glSortirProprement("FOUTAGE DE GUEULE !!!!!");}
        PtIma=(uchar *)malloc(SizeImage);

        fgetpos(fptr,&PosAct);	if (PosAct!=54) {glSortirProprement ("Oups ! BMP != 54... I did it again!");}
        int Poubelle[3];
        int Nb= (Tx *3) %4;
        if (Nb==1){Nb=3;} else if (Nb==3) {Nb=1;}

        uchar * Pt=PtIma;
        for (int y=0;y<Ty;y++)
        {
                fread(Pt,Tx *3,1,fptr);
                fread(&Poubelle,Nb,1,fptr);
                Pt+=Tx *3;
        }

        FlipRB( PtIma, Tx*Ty,3);
        fclose(fptr);
        Reverse(PtIma,Tx,Ty,NbCh); //!!!!!!!!! HA HA HA !!!!!!!!!!!!!!!!!!!!!!!
}
bool TFonteLoc::Load(string NF)
{
        string NFTxt=NF+".txt";   if (!Files.Exists(NFTxt)) {glSortirProprement(NFTxt+" non trouv");return(false);}
        string NFBmp=NF+".bmp";         if (!Files.Exists(NFBmp)) {glSortirProprement(NFBmp+" non trouv");return(false);}

        // **** 1) Le TXT
        TFile F;
        unsigned char ch;
        F.Load(NFTxt.c_str());
        NbPixMaxX=0; MaxYunder=MaxYover=0;
        NbPixMaxY=0;
        while (F.GoNxtChar('='))
        {                               int yup=    F.ReadIntAct();
                F.GoNxtChar('=');       int yalign= F.ReadIntAct();
                F.GoNxtChar('=');       int ydown=  F.ReadIntAct();
                if (ydown-yup>NbPixMaxY) NbPixMaxY=ydown-yup;

                do
                {       ch=F.MoveToNxtChar(); TLettre * L=&(this->Let[ch]); // Lettre actuelle
                        F.Str++;
                        F.MoveToNxtChar();  L->x1=F.ReadIntAct();
                        F.MoveToNxtChar();  L->x2=F.ReadIntAct();
                        while (*F.Str==' ') F.Str++;
                        if (*F.Str!=10 && *F.Str!=13) L->xdec = F.ReadFloatMove(); // Si y'a xdec, on le lit :)
                        ch=F.MoveToNxtChar();

                        if (L->x2 - L->x1>NbPixMaxX) NbPixMaxX=L->x2 - L->x1;
                        L->yu=yup; L->yd=ydown; L->ya=yalign;
                        if (yalign -yup   >MaxYover)  MaxYover  = yalign - yup;
                        if (ydown -yalign >MaxYunder) MaxYunder = ydown  - yalign;
                } while ( (ch)&&(F.Str[1]!='%') );
        }
        F.FreeData();

        //**** 2) La BMP
        gl.FreeTex(Tex);
        XLoader. LoadTxTyBMP    ( NFBmp, TxBMP, TyBMP);
        XLoader. LoadBMPAlpha   ( NFBmp, &Tex);

        return(true);
}








//--------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------
// Recopi par Xavier Chauvet, le 7 juillet 2010, intgralement mais en comprenant  80% :
// http://www.cs.virginia.edu/~gfx/Courses/2003/ImageSynthesis/papers/Acceleration/Fast%20MinimumStorage%20RayTriangle%20Intersection.pdf
//--------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------

#define EPSILON 0.00001
#define CROSS(dest,v1,v2) dest[0]=v1[1]*v2[2]-v1[2]*v2[1];   dest[1]=v1[2]*v2[0]-v1[0]*v2[2]; dest[2]=v1[0]*v2[1]-v1[1]*v2[0];
#define DOT(v1,v2) (v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2])
#define SUB(dest,v1,v2) dest[0]=v1[0]-v2[0]; dest[1]=v1[1]-v2[1]; dest[2]=v1[2]-v2[2];

TglMaths glMaths;

bool TglMaths::intersect_triangle(float orig[3], float dir[3], float vert0[3], float vert1[3], float vert2[3]) // l'orientation de ton triangle n'importe pas pour la dtection
{
   double edge1[3], edge2[3], tvec[3], pvec[3], qvec[3];
   double det,inv_det,u,v;

   SUB  (edge1, vert1, vert0);   SUB(edge2, vert2, vert0);
   CROSS(pvec, dir, edge2);
   det = DOT(edge1, pvec);
   if (det > -EPSILON && det < EPSILON)     return 0;
   inv_det = 1.0 / det;
   SUB(tvec, orig, vert0);
   u = DOT(tvec, pvec) * inv_det;
   if (u < 0.0 || u > 1.0)     return 0;
   CROSS(qvec, tvec, edge1);
   v = DOT(dir, qvec) * inv_det;
   if (v < 0.0 || u + v > 1.0)  return 0;
   //*t = DOT(edge2, qvec) * inv_det;
   return 1;
}
/*
bool TglMaths::intersect_triangle_ORIENTATION_IMPORTE(float orig[3], float dir[3], float vert0[3], float vert1[3], float vert2[3]) // ton putain de triangle doit tre "bien" orient sinon a dtecte pas... :(((
{
	float edge1[3],edge2[3],tvec[3],pvec[3],qvec[3];
	float det, u,v;

	SUB(edge1, vert1, vert0);	SUB(edge2, vert2, vert0); // find vectors for two edges sharing vert[0]
	CROSS(pvec, dir, edge2);  //begin calculating det - also used to calc u parameter
	det=DOT(edge1, pvec);
	if (det < EPSILON ) return false;

	SUB(tvec, orig, vert0);                           // calc dist from vert0 to ray origin
	u=DOT(tvec, pvec); if (u<0.0 || u>det) return 0; // calc u and test bounds

	CROSS (qvec, tvec, edge1);                             // prepare to test v parameter
	v=DOT(dir, qvec);  if (v<0.0 || u+v>det) return 0; // calc v and test bounds

	// float t;   // t=dist de orig  l'intersection (ray/tri)   u,v=coord baryc
	// t=DOT(edge2, qvec); si on veut calculer t, u et v	// float inv_det=1.0/det;
	// t *= inv_det;	// u *= inv_det;	// v *= inv_det;
	return(true);
}
*/
//--------------------------------------------------------------------------------------------
bool TglMaths::CoupeCarre(float *v0, float *v1, float *v2, float *v3) // InitLaser doit avoir t effectu :)
{       if (intersect_triangle(w0, dir, v0,v1,v2)) return(true);
        if (intersect_triangle(w0, dir, v0,v2,v3)) return(true);
        return(false);
}
//--------------------------------------------------------------------------------------------
void TglMaths::InitLaser (GLuint xEcr, GLuint yEcr)
{
        GLint viewport[4];                            GLdouble mvmatrix[16], projmatrix[16];
        glGetIntegerv (GL_VIEWPORT, viewport);        glGetDoublev  (GL_MODELVIEW_MATRIX ,   mvmatrix);        glGetDoublev  (GL_PROJECTION_MATRIX, projmatrix);
        int yEcrInv = viewport[3]- yEcr - 1;                       // viewport[3] est la hauteur de la fentre en pixels

        double dw0[3],dw1[3];
        gluUnProject  (xEcr, yEcrInv, 0, mvmatrix, projmatrix, viewport, &dw0[0], &dw0[1], &dw0[2]); // on rcupre le point3D au Frustum z=0
        gluUnProject  (xEcr, yEcrInv, 1, mvmatrix, projmatrix, viewport, &dw1[0], &dw1[1], &dw1[2]); // on rcupre le point3D au Frustum z=1
        float w1[3]; for (int k=0; k<3; k++) {w0[k]=dw0[k]; w1[k]=dw1[k];}
        SUB(dir,w1,w0); // Origine = w0   Direction = dir
}
//--------------------------------------------------------------------------------------------
int TglMaths::TriAtteint_Terrain_Click (GLuint xEcr, GLuint yEcr, float * Pts_3f, UINT * Tri_Idx, int ResX, int ResZ) // y'a ResZ-1 ranges de 2*ResX Points, comme dans TTerrain
{       InitLaser(xEcr,yEcr);
        float * v0, *v1, *v2;
        int IdxT, TriOut = -1;        float Dist=0; // Distance de l'origine  un triangle atteint
        for (int kz=0  ;  kz <  ResZ-1  ;  kz++)
        {         IdxT = 2*kz*ResX; // ( vrifi pour ResX=5 )
                  for (int ktx=0 ; ktx<2*(ResX-1) ; ktx++) // il y a 2*(ResX-1) triangles  chaque range ( vrifi pour ResX=5 )
                  {       v0 = &Pts_3f[3*Tri_Idx[IdxT  ]];
                          v1 = &Pts_3f[3*Tri_Idx[IdxT+1]];
                          v2 = &Pts_3f[3*Tri_Idx[IdxT+2]]; //if (ktx%2==1) {vtmp=v1; v1=v2; v2=vtmp;}
                          if (intersect_triangle(w0, dir, v0,v1,v2))
                          {
                                  float nDist= SQR(w0[0]-v0[0]) + SQR(w0[1]-v0[1]) + SQR(w0[2]-v0[2]);
                                  if (Dist==0 || nDist<Dist) {TriOut=IdxT;Dist=nDist;}
                          }
                          IdxT++;
                  }
        }
        return (TriOut);
}
//--------------------------------------------------
void TglMaths::SaveLigne(GLuint xEcr, GLuint yEcr)
{       xEc=xEcr; yEc=yEcr;
        GLint viewport[4];                            GLdouble mvmatrix[16], projmatrix[16];
        glGetIntegerv (GL_VIEWPORT, viewport);        glGetDoublev  (GL_MODELVIEW_MATRIX ,   mvmatrix);        glGetDoublev  (GL_PROJECTION_MATRIX, projmatrix);
        int yEcrInv = viewport[3]- yEcr - 1;

        double dw0[3],dw1[3];
        gluUnProject  (xEcr, yEcrInv, 0, mvmatrix, projmatrix, viewport, &dw0[0], &dw0[1], &dw0[2]); // on rcupre le point3D au Frustum z=0
        gluUnProject  (xEcr, yEcrInv, 1, mvmatrix, projmatrix, viewport, &dw1[0], &dw1[1], &dw1[2]); // on rcupre le point3D au Frustum z=1
        for (int k=0; k<3; k++) {F0[k]=dw0[k]; F1[k]=dw1[k];}
}
//--------------------------------------------------
void TglMaths::DrawLigne()
{
        glDisable(GL_TEXTURE_2D); glPointSize(4);
        glColor3f(0,0.5,0.2);
        glBegin(GL_LINES); v3f(F0[0],F0[1],F0[2]); v3f(F1[0],F1[1],F1[2]); glEnd();
}
//--------------------------------------------------

//********************************************************************************************************************************************************
//********************************************************************************************************************************************************
//********************************************************************************************************************************************************
//********************************************************************************************************************************************************
//********************************************************************************************************************************************************
TWebCamDst WCDst;
//******************************************************************************************************************************
bool TWebCamDst::Init()   // Init Texture Open GL
{
        WCF    = (TWebCamData*)Create(sizeof(TWebCamData));
        if (WCF==NULL) return(false);
	glGenTextures   (1,&WCF->TexCam);
	glBindTexture   (GL_TEXTURE_2D,WCF->TexCam);
	glTexImage2D    (GL_TEXTURE_2D,0,GL_RGB  ,TxCAMTex,TyCAMTex,0,GL_RGB,GL_UNSIGNED_BYTE,WCF->Cam[0]);
	return (true);
}
//---------------------------------------------
TWebCamData * TWebCamDst::Create(int NbOctets)
{
return(NULL);
}
//---------------------------------------------
void TWebCamData::glTextureCam()
{       uchar * PtCam = Cam[0];
	if (kAcCam==-1) return;
	if (!TexCree)
	{
		TexCree=true;
		glGenTextures(1,&TexCam);
		glBindTexture(GL_TEXTURE_2D,TexCam);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexImage2D   (GL_TEXTURE_2D, 0,GL_RGB8,TxCAMTex,TyCAMTex,  0,GL_RGB, GL_UNSIGNED_BYTE,PtCam);
		LastkAcCam=kAcCam;
		return;
	}

	if (LastkAcCam==kAcCam){glTexture(TexCam);}
	else{
		glBindTexture(GL_TEXTURE_2D,TexCam);
		glTexSubImage2D(GL_TEXTURE_2D, 0,0,0,TxCAMTex,TyCAMTex,GL_RGB,GL_UNSIGNED_BYTE,PtCam);
		LastkAcCam=kAcCam;	}
}
//********************************************************************************************************************************************************
//********************************************************************************************************************************************************
//********************************************************************************************************************************************************

