//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      XDS GL - MARS 2002 - CopyRight  XDS Corporation		*****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************
#ifndef __XDSGL
#define __XDSGL

#include "XDSFree.h"
#include "XMaths.h"
#include "KTime.h"

#include <GL/gl.h>
#include <GL/glExt.h>

//#pragma comment(lib, "opengl32.lib")
//#pragma comment(lib, "glu32.lib")
//#pragma comment(lib, "glaux.lib")

#define v2f glVertex2f
#define v3f glVertex3f
#define t2f glTexCoord2f
#define n3f glNormal3f
inline void glTexture(GLuint a) {glBindTexture(GL_TEXTURE_2D,a);}
inline void glEnableVar(bool enable,GLuint Idx){if (enable) glEnable(Idx);else glDisable(Idx);}
inline void glId()   {glMatrixMode(GL_MODELVIEW);glLoadIdentity();};


//***************************************************************************
//******** gl  **************************************************************
//***************************************************************************

class Tgl
{ public :
  void ClrScr (float r,float v,float b){glClearColor(r,v,b,1);  glClear(GL_COLOR_BUFFER_BIT);}
  void ClrScr2(float r,float v,float b){glClearColor(r,v,b,1);  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);}
  void ClrScr3()                       {                        glClear(GL_DEPTH_BUFFER_BIT);}
  void ColorON(float r,float v,float b){glTexEnvi	(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);glColor3f(r,v,b);}
  void ColorOFF()                      {glTexEnvi	(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);}//### GL_BLEND , GL_MODULATE
  void SetScreen2D(int Width,int Height,bool ZeroEnHaut);
  void Restart();
  void MV()             {glMatrixMode(GL_MODELVIEW);}
  void PushTexture()    {glMatrixMode(GL_TEXTURE);glPushMatrix();MV();}
  void PopTexture()     {glMatrixMode(GL_TEXTURE);glPopMatrix(); MV();}
  void RotatefTex    (float ang,float x,float y,float z)  {glMatrixMode(GL_TEXTURE);glRotatef(ang,x,y,z);MV();}
  void RotatefTexCen (float ang,float x,float y,float z)  {glMatrixMode(GL_TEXTURE);glTranslatef(0.5,0.5,0);glRotatef(ang,x,y,z);glTranslatef(-0.5,-0.5,0);MV();}
  void SetTexture    (float x1,float y1,float x3,float y3){glMatrixMode(GL_TEXTURE);glTranslatef(x1,y1,0);glScalef(x3-x1,y3-y1,1);MV();}
  void SetTexture2 (int idxx,int idxy,int NbCasesX,int NbCasesY){glMatrixMode(GL_TEXTURE);                 glTranslatef((float)idxx/(float)NbCasesX,(float)idxy             /(float)NbCasesY,0);glScalef(1/(float)NbCasesX,1/(float)NbCasesY,1);MV();}
  void SetTextureId(int idxx,int idxy,int NbCasesX,int NbCasesY){glMatrixMode(GL_TEXTURE);glLoadIdentity();glTranslatef((float)idxx/(float)NbCasesX,(float)(NbCasesY-1-idxy)/(float)NbCasesY,0);glScalef(1/(float)NbCasesX,1/(float)NbCasesY,1);MV();}
  void RotateAff   (float Angle360,float x1,float y1,float z1,float x2,float y2,float z2){glTranslatef (x1,y1,z1);glRotatef    (Angle360,(x2-x1),(y2-y1),(z2-z1));glTranslatef (-x1,-y1,-z1);}
  void FreeTex     (uint &Tex){if (Tex) {glDeleteTextures(1,&Tex); Tex=0;}}
  void CarreRond (float xC, float yC, float z, float tx, float ty, float factRond,int NbLam15,GLuint tex);
  void RandColor (bool Gris,float Fact01){float Fact=Fact01;float r1,r2,r3;if (Gris){r1=float(rand())/RAND_MAX*Fact;glColor3f(r1,r1,r1);}else{r1=float(rand())/RAND_MAX*Fact;r2=float(rand())/RAND_MAX*Fact;r3=float(rand())/RAND_MAX*Fact;glColor3f(r1,r2,r3);}};

  void SetReplace   ()  {  glTexEnvi	(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE );     }
  void SetModulate  ()  {  glTexEnvi	(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);     }
  void SetCombine   ()  {  glTexEnvi    (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE_ARB ); glTexEnvi( GL_TEXTURE_ENV, GL_RGB_SCALE_ARB, 2 ); }
  void EnableRep    ()  {  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);glEnable(GL_TEXTURE_GEN_S);glEnable(GL_TEXTURE_GEN_T);}
  void EnableBlend  ()  {  glEnable  ( GL_BLEND ); glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);}
  void EnableSpr    ()  {  glEnable  ( GL_ALPHA_TEST ); glAlphaFunc(GL_GREATER, 0.0f);}
  void DisableRep   ()  {  glDisable ( GL_TEXTURE_GEN_S);glDisable(GL_TEXTURE_GEN_T);}
  void DisableBlend ()  {  glDisable ( GL_BLEND );}
  void DisableSpr   ()  {  glDisable ( GL_ALPHA_TEST );}


  void DrawPt2D    (int x1,int y1,            float size=1,float  R=1,float V=0,float B=0);
  void DrawPt3D    (float x,float y,float z,  float size=1,float  R=1,float V=0,float B=0);
  void DrawLine    (T3f &A, T3f &M,           float size=1,float  R=1,float V=1,float B=0) {Line(A.x,A.y,A.z,M.x,M.y,M.z,size,R,V,B);}
  void DrawRect    (TXRect &R     ,           float size=1,float RR=1,float V=1,float B=0);
  void DrawRect    (float x1,float y1, float x2,float y2, float size=1,float RR=1,float V=1,float B=0);
  void Line                (float x,float y,float z,float xx,float yy,float zz,float R=1, float V=1, float B=1, float size=1);

  void CarreZCST           (float x1,float y1,float x3,float y3,float tx1,float ty1,float tx2,float ty2){glBegin(GL_QUADS);t2f(tx1,ty1)  ;v3f(x1,y1,1);t2f(tx1,ty2)  ;v3f(x1,y3,1);t2f(tx2,ty2)  ;v3f(x3,y3,1);t2f(tx2,ty1)  ;v3f(x3,y1,1);glEnd();}
  void CarrezCST           (float x1,float y1,float x2,float y2,float x3,float y3,float x4,float y4,float z){glBegin(GL_QUADS);t2f(0,0);v3f(x1,y1,z);t2f(1,0);v3f(x2,y2,z);t2f(1,1);v3f(x3,y3,z);t2f(0,1);v3f(x4,y4,z);glEnd();}
  void CarrezCST2          (float x1,float y1,float x3,float y3,float z,GLuint Texture){if (Texture!=(GLuint)-1) glTexture(Texture);CarrezCST(x1,y1,x3,y1,x3,y3,x1,y3,z);}
  void CarrezCST2Centre    (float xC,float yC,float tx,float ty,float z,GLuint Texture)                                    {CarrezCST2( xC-tx/2,yC-ty/2  , xC+tx/2,yC+ty/2 ,z,Texture);}
  void CarrezCST2RotzCentre(float x1,float y1,float tx,float ty,float z,float Rot90,GLuint Texture);
  void CubeRondXELIM       (float xC,float yC,float z, float tx,float ty,float tz, float FactRond, int NbLam15,float toui,float tnon,float thoche, GLuint TexFace,GLuint TexAutre);
  void CubeTex             (float x, float y, float z, float tx,float ty,float tz,int Texture);
  void CubeTexCentre       (float xC,float yC,float zC,float tx,float ty,float tz,int Texture);
  void Sphere              (float x ,float y ,float z,float r,int NbEta20,int NbMer20,GLuint TexSphere,float translx,float transly);

  void ScreenShot          (char * NomFich);
} extern gl;


class Tglut
{public :
    void DrawRepere  (float xc, float yc, float zc, float R, float V, float B, float RayB01);
} extern glut;

//***************************************************************************
//******** TRepere **********************************************************
//***************************************************************************
const int NBKEYSCAM = 14;
//--- A METTRE EN GLOBAL ---
extern int    KeyMove[NBKEYSCAM];          // 0=Avance  1=Recule 2=tourneGauche 3=tourneDroite 4=ShiftGauche 5=ShiftDroite 6=VolerUp 7=VolerDown 8=tOUI_Up 9=tOUI_Down 10=Avance3D 11=VolerUp
extern float DistMove[NBKEYSCAM];          // en distance par seconde
extern float SensiX,SensiY;                // pour Souris

class TRepere {
public :
    float_time tetZ,tetY,tetX,x,y,z; // angles en radian pour TRepere, et en 360Degrs pour OpenGL
    bool IsCamera,AffRepere;
    float Scale;
    float Sx,Sy,Sz; // Scale xyz

    //--- Utiles
    void Refresh();
    void DrawRepere();
    void DrawReperexyz(T3f * xyz);         // Dessine la b.o.n. xyz en R.GetT3f

    //--- Souris / Clavier
    void Avance  (float dist,float duree); // Dans le plan (0 x z) seulement
    void Avance3D(float dist,float duree); // Dans la direction 3D, quitte  modifier y
    void Shift   (float dist,float duree);
    void Vole3D  (float dist,float duree); // pas que y : on modifie les 3 coordonnes !!

    void Avance3D2(float dist,float duree, T3f * xyz); // Dans la direction 3D, quitte  modifier y
    void Shift2   (float dist,float duree, T3f * xyz);
    void Vole3D2  (float dist,float duree, T3f * xyz); // pas que y : on modifie les 3 coordonnes !!

    //--- 6 coordonnes
    void Set        (float xx,float yy,float zz,float ttetX, float ttetY, float ttetZ)          {x=xx; y=yy; z=zz; tetX=ttetX;  tetY=ttetY;  tetZ=ttetZ;}
    void SetTet     (                           float ttetX, float ttetY, float ttetZ)          {                  tetX=ttetX;  tetY=ttetY;  tetZ=ttetZ;}
    void SetInstant (float xx,float yy,float zz,float ttetX, float ttetY, float ttetZ)          {x.Fixe(xx); y.Fixe(yy); z.Fixe(zz); tetX.Fixe(ttetX);  tetY.Fixe(ttetY);  tetZ.Fixe(ttetZ);}
    void SetInstantT3f(T3f &C) {x.Fixe(C.x);  y.Fixe(C.y);  z.Fixe(C.z);}
    T3f  GetT3f() {T3f res; res.x=x.a(); res.y=y.a(); res.z=z.a(); return(res);}
    void SetFromCam (TRepere &SRC)   {x=SRC.x.fin; y=SRC.y.fin;  z=SRC.z.fin;  tetX=SRC.tetX.fin;  tetY=SRC.tetY.fin;  tetZ=SRC.tetZ.fin;}
    void SetAllDuree(float dur) {tetZ.duree=tetY.duree=tetX.duree=x.duree=y.duree=z.duree=dur;}

    //--- Scale x y z
    void SetPosInstant  (float xx,float yy,float zz) {x.Fixe(xx);y.Fixe(yy);z.Fixe(zz);}
    void SetScale       (float sx,float sy,float sz) {Sx=sx; Sy=sy; Sz=sz;}

    //--- Souris / Clavier
    void MoveCameraSouris        ();            void MoveCameraKTime         ();
    void MoveCameraSouris2       (T3f *xyz);    void MoveCameraKTime2        (T3f *xyz);
    void MoveCameraKTimeSouris   ()         {MoveCameraKTime ();   MoveCameraSouris ()   ;}
    void MoveCameraKTimeSouris2  (T3f *xyz) {MoveCameraKTime2(xyz);MoveCameraSouris2(xyz);}
    void SetDistMove          (float dAvancePerSec1, float angRotPerSec3=3);
    void SetDistMoveInverse() {for (int k=0; k<=10; k++) DistMove[k]=-DistMove[k];}

    //--- Maths
    void GetRepereOrtho (T3f * xyz);   // renvoie un repre xyz norm, sur l'axe (Origine, Point de fuite)
    void Conv2D3D       (float xIn, float yIn, float zIn01,  T3f &PtOut); // Quel repre pour xIn et yIn ??
    void Souris2Plan    (float xIn, float yIn, T3f * xyzIN, T3f O_IN, T3f &M_Out);

    void GetCenterFrustum  (T3f &cf);   // renvoie le point (0, 0 ,0.5) de la frustum

    //--- Mthodes
    void SaveFile(TFilew  &F);
    void LoadFile(TFilerb &F);

    //--- Debug
    string StrCam()    ;   // x, y, z
    string StrCamTet() ;   // tetX, tetY, tetZ
    string StrCamALL ();   // All
    string StrCamxS()  ;   // x y z et S Sx Sy Sz
    void   StrCamxSRECIPR(string s);

    string StrCam2()   ;   // x, y, z                  SANS "x:"
    string StrCamTet2();   // tetX, tetY, tetZ         SANS "x:"
    string StrCamALL2();   // All                      SANS "x:"
    TRepere(bool IsCam=false, float DistPerSec=3);

private :
    void MoveCameraSouris (float dx, float dy);

};

void DrawCone       (float tz, float r); // ce cne pointe vers les z ngatifs, et x,y,z est le centre du gd cercle
void DrawRepereOrtho(T3f Centre, T3f * xyz);
//***************************************************************************
//******** TCamera **********************************************************
//***************************************************************************
//
//   la scne est vers les z<0

class TCamera : public TRepere {
public :
    float Near,Far,AngleOuv;
    void InitProjection(float Angle45,float RatioWidthHeight, float zNear001, float zFar100);
    void InitProjection() {InitProjection( 45.0, 1, 0.001, 100.0);}

    //--- Frustum
    void Frustum_Calc    (T3f * FF); // Les 4 extrmits_far, puis la camra
    void Frustum_Calc8Pts(T3f * FF); // Les 8 points du Frustum

    TCamera() {
        IsCamera=true;
        SensiX = 0.4;
        SensiY = 0.4;
        SetDistMove(2,3);
        InitProjection();
        SetAllDuree(0);
    }
};
// MODULO 2 PI !!!??? T'y songes ??
//***************************************************************************
//******** TXYZ *************************************************************
//***************************************************************************
//
//  Dfinition : un XYZ est un T3f[3] formant une b.o.n.
//
struct TXYZ{
        void BuildTransfo(T3f * xyzIN, double M[16]); //
        void ProjOrtho   (T3f &A_IN,   T3f &O_IN, T3f*xyz_IN,  T3f &H_OUT);
} extern XYZ;



//***************************************************************************
//*********** TColorX *******************************************************
//***************************************************************************
class TColorX {
public :
    float rgba[4]; // devra tre prive,  terme.
    float R() {return(rgba[0]);}
    float G() {return(rgba[1]);}
    float B() {return(rgba[2]);}

private :
    void SetRGBuc  (uchar *RGB) {rgba[0]=(*RGB++)/255.0; rgba[1]=(*RGB++)/255.0; rgba[2]=(*RGB)/255.0;}
    void SetRGBf   (float *RGB) {rgba[0]=RGB[0];         rgba[1]=RGB[1];         rgba[2]=RGB[2];}

    void SetRGBuc  (uchar r, uchar g, uchar b) {rgba[0]=r/255.0; rgba[1]=g/255.0; rgba[2]=b/255.0;}
    void SetRGBf   (float r, float g, float b) {rgba[0]=r;       rgba[1]=g;       rgba[2]=b;}

    void TColorToRGBf (int Color, float* RVB);  // indpendant des donnes de l'objet !
    void RGBfToTColor (float* RVB, int *Color); // indpendant des donnes de l'objet !
};

//*************************************************
//***** 4 ***** Lecture Fichiers ******************
//*************************************************
/*void glLoadJPG	        (string Filename,GLuint * IdxTexture);
void glLoadJPG          (string Filename,GLuint * IdxTexture,int &tx, int &ty);
void glLoadJPGTxTy      (string Filename,int &tx, int &ty);
void glLoadTGA          (string FileName,GLuint * IdxTexture);
void glLoadBMP	        (string Filename,GLuint * IdxTexture);
void glLoadBMPSpr	(string Filename,GLuint * IdxTexture);
void glLoadBMPSprAlpha	(string Filename,GLuint * IdxTexture);
void glScreenShot	(string * NomFich);
void glScreenShot2      (char ** PtPix,bool ToBeMalloced);
*/

void RemixTexAndLight(string NomFichTex, string NomFichLight, string NomOut, bool HSL);
bool intersect_triangle(float orig[3], float dir[3], float vert0[3], float vert1[3], float vert2[3]);

//*************************************************
//***** 4bis **** Maths ***************************
//*************************************************
class TglMaths { public :
        int TriAtteint_Terrain_Click (GLuint xEcr, GLuint yEcr, float * Pts_3f, UINT * Tri_Idx, int ResX, int ResZ);  // y'a ResZ-1 ranges de 2*ResX Points, comme dans TTerrain
        bool intersect_triangle(float orig[3], float dir[3], float vert0[3], float vert1[3], float vert2[3]);        // Puissance des mecs forts.

        //--- Init ---
        float w0[3],dir[3];
        void InitLaser (GLuint xEcr, GLuint yEcr); // Calcule w0 et dir
        bool CoupeCarre(float *v0, float *v1, float *v2, float *v3);

        //--- Debug ---
        void SaveLigne(GLuint xEcr, GLuint yEcr);       // met  jour F0 et F1
        void DrawLigne();                               // Dessine le segment [F0,F1]
        float F0[3];    float F1[3];    float xEc, yEc; int TriMem;

        TglMaths() {Zero(F0);Zero(F1);xEc=yEc=0; TriMem=0;}

} extern glMaths;

class TglConv { public :
        void Conv2D ( vector <T2f> V, vector <int> &Idx );
} extern glConv;


//*******************************************************************
//***** glTunnel ****************************************************
//*******************************************************************
//    Notice : Renvoie (TRUE ssi c'est FINI)
//    Notice : VitesseConstante : TRUE, comme a y'a pas besoin de AngleManuel.
//    Notice : DebutDeOnVire : 0 ou la date de dpart (en millisecondes, of course)
bool glTunnel   (GLuint Tex,bool VitesseConstante,float AngleManuel,bool glClearAll,float tact,float DebutDeOnVire,float TempsPourVirer,bool FonduTunnel);
bool glTunnel01 (GLuint Tex,bool VitesseConstante,float AngleManuel,bool glClearAll,float tact,float PartieAff01                       ,bool FonduTunnel);

//*******************************************************************
//***** 8 ***** Le Piano ********************************************
//*******************************************************************
struct TPiano {	short int K [256];
                int NbTouches37;
                float x,y,z,tx,ty,tz,TetOui,TetNon,TetHoche;
                GLuint TexNoire,TexBlanc;};
void InitPiano(TPiano * P,float tx1Case,float ty,float tz,GLuint TexNoire,GLuint TexBlanc,int NbTouches18);
int Key2NoteDT (WORD key);// renvoie 0=si, 1=Do, 2=Do# ... etc
void DrawPiano (TPiano * P);

//*******************************************************************
//***** 11 ***** TSkyBox  *******************************************
//*******************************************************************
class TSkyBox { public :
        uint Tex[6];
        TSkyBox() {Zero(Tex); Zero(Rot);}
        void Load  (string NomRep, string NomFile, int SysFile,char * CodeNULL); // SysFile1=0 ou 1 ou 2  S.Load( "SkyBoxes\\22\\" , "" , 2 ,NULL);
        void Draw  (float TT,float RotRAD);
        char Rot[6]; // char entre 0 et 3
};
//*******************************************************************
//***** 11bis ***** TBombe ******************************************
//*******************************************************************
class TGLBombe { public :
        GLuint TexBombe,TexCorde,TexExpl[50];
        void Draw (float xC,float yC,float z, float txBombe, float tyFil, int Typ012, int kAction); // Typ0=NoExpl Typ1=VaEtVient Typ2=Modulo
        void Load (string TexB, string TexC, string TexE, int NbExpl);
        int NbExpl;
};
//*******************************************************************
//***** 12 ***** TexEnv *********************************************
//*******************************************************************
class TTexEnv { public :   void Get()
                           {    DepthEnabled = glIsEnabled(GL_DEPTH_TEST);
                                TexEnabled   = glIsEnabled(GL_TEXTURE_2D);
                                BlendEnabled = glIsEnabled(GL_BLEND);
                                glGetIntegerv( GL_TEXTURE_BINDING_2D, &binding); ///// Pas remis car je sais pas ce que c'est :)
                                glGetTexEnviv( GL_TEXTURE_ENV   , GL_TEXTURE_ENV_MODE,  &mode);
                                glGetTexEnvfv( GL_TEXTURE_ENV   , GL_TEXTURE_ENV_COLOR, CurrentTexColor);
                                glGetIntegerv( GL_SHADE_MODEL   , &ShadeModel);
                                glGetFloatv  ( GL_CURRENT_COLOR , CurrentColor);
                                glGetIntegerv( GL_VIEWPORT      , ViewPort);
                            }
                            void Set()
                            {   glEnableVar(DepthEnabled , GL_DEPTH_TEST);
                                glEnableVar(TexEnabled   , GL_TEXTURE_2D);
                                glEnableVar(BlendEnabled , GL_BLEND);
                                glTexEnvi  (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,  mode);
                                glTexEnvfv (GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, CurrentTexColor);
                                glShadeModel(ShadeModel);
                                glColor4fv(CurrentColor);
                                glViewport(ViewPort[0],ViewPort[1],ViewPort[2],ViewPort[3]);
                            }

                            void SetModeLine(){glDisable(GL_TEXTURE_2D);glDisable(GL_DEPTH_TEST);}

                           GLfloat CurrentColor   [4];
                private :
                           GLint TexEnabled, BlendEnabled, DepthEnabled;
                           GLint binding;
                           GLint mode;
                           GLfloat CurrentTexColor[4];
                           GLint   ViewPort[4];
                           GLint ShadeModel;

} extern TexEnv;

//*******************************************************************
//***** 12 ***** TFonte *********************************************
//*******************************************************************
class TConfigFont { public :
                TConfigFont(){SetConf(0,0, false,-1); };
                bool Verbatim;      // Verbatim :)
                int   Cu,Cd;        // CouleurUp et CouleurDown  (0,0=NoColor) 0xRRVVBB
                int TexConf;        // Texture de la configuration : brique.. etc ( pas encore fait ^^ )
                float ru(){return ((float)( Cu>>16     )/256.0);}                float rd(){return ((float)( Cd>>16     )/256.0);}
                float gu(){return ((float)((Cu>>8) %256)/256.0);}                float gd(){return ((float)((Cd>>8) %256)/256.0);}
                float bu(){return ((float)( Cu     %256)/256.0);}                float bd(){return ((float)( Cd     %256)/256.0);}

                void SetConf(float CU,float CD, bool VerbatiM, int TexConF) {Cu=CU; Cd=CD; Verbatim=VerbatiM; TexConf=TexConF; };

};
//------------------------------------------
class TLettre { public : int yu, yd, ya, x1, x2; float xdec;
                        TLettre() {yu=yd=ya=x1=x2=0;xdec=0;}
};
//------------------------------------------
class TFonteLoc { public :
        TFonteLoc(){Tex=0;};
        TConfigFont Conf[10];
        TLettre Let[256];
        int     TxBMP      ,  TyBMP;
        int     NbPixMaxX  ,  NbPixMaxY;
        int     MaxYunder  ,  MaxYover; // nb pix au max UNDER le ya, et nb pix au max OVER le ya
        GLuint  Tex;
        bool Load(string NomFichNoExt);
        float Wri         (float x, float y, float z,float tx,float ty,string Txt,float kFonte); // tx = taille de lettre la + large (x ,y) = coord en BAS_Align  GAUCHE
        float WriBlitting (float x, float y,                           string Txt);
        void  WriShadow   (float x, float y, float z,float tx,float ty,string Txt,float kFonte, float alpha_shadow01, float decx1, float decy1);
        float WriCentre   (float x, float y, float z,float tx,float ty,string Txt,float kFonte); // tx = taille de lettre la + large (xC,y) = coord en BAS_Align CentreX
        float TxWri(float tx, string Txt);
};

class TFonte {public : // kFonte = 5.1 signifie que c'est la fonte 5 et le ConfigFont 1
        TFonteLoc F[100];
        int  kConf      (float kFonte) {return ( ((int)((kFonte+0.001)*10))%10 );} /// D'o viennent ces PUTAINS d'ERREURS NUMERIQUES !!?? 5.1 devient 5.09999999645 !?!!
        void Load       (string NomFichNoExt,float kFonte) {F[(int)kFonte].Load(NomFichNoExt);};
        float kFontAct;
        void SetConf    (float kFonte, float CU,float CD, bool VerbatiM, int TexConF) {F[(int)kFonte].Conf[kConf(kFonte)].SetConf(CU,CD,VerbatiM,TexConF);}
        float Wri        (float x, float y, float z,float tx,float ty,string Txt,float kFonte) {return(F[(int)kFonte]  .Wri (x,y,z,tx,ty,Txt,kFonte));}
        float Wri        (float x, float y, float z,float tx,float ty,string Txt)              {return(F[(int)kFontAct].Wri (x,y,z,tx,ty,Txt,kFontAct));}
        float WriBlitting(float x, float y,string Txt,float kFonte)                            {return(F[(int)kFonte]  .WriBlitting(x,y,Txt));}
        float WriCentre  (float x, float y, float z,float tx,float ty,string Txt,float kFonte) {return(F[(int)kFonte]  .WriCentre  (x,y,z,tx,ty,Txt,kFonte));}
        float WriCentre  (float x, float y, float z,float tx,float ty,string Txt)              {return(F[(int)kFontAct].WriCentre  (x,y,z,tx,ty,Txt,kFontAct));}
        void  WriShadow  (float x, float y, float z,float tx,float ty,string Txt,float kFonte, float alpha_shadow01, float decx1, float decy1) {F[(int)kFonte]   .WriShadow (x,y,z,tx,ty,Txt,kFonte  ,alpha_shadow01,decx1,decy1);}
        void  WriShadow  (float x, float y, float z,float tx,float ty,string Txt,              float alpha_shadow01, float decx1, float decy1) {F[(int)kFontAct] .WriShadow (x,y,z,tx,ty,Txt,kFontAct,alpha_shadow01,decx1,decy1);}
        float TxWri     (float tx, string Txt)              {return(F[(int)kFontAct].TxWri(tx,Txt));}
        float TxWri     (float tx, string Txt,float kFonte) {return(F[(int)kFonte]   .TxWri(tx,Txt));}
        float MaxYunder (float kFonte) {return(F[(int)kFonte].MaxYunder);}              float MaxYunder () {return(F[(int)kFontAct].MaxYunder);}
        float MaxYover  (float kFonte) {return(F[(int)kFonte].MaxYover );}              float MaxYover  () {return(F[(int)kFontAct].MaxYover );}

        TFonte(){
        kFontAct=0;}
} extern Fontes; // dfini dans XCSGL.cpp

//*******************************************************************
//***** 13 ***** WebCam *********************************************
//*******************************************************************
const int TxCAM = 352;
const int TyCAM = 288;
const int TxCAMTex = 256;
const int TyCAMTex = 256;
//-------------------------------------------------------
const int Long_Cycle_WebCam   = 5;
class TWebCamData
{public :
        uchar  Cam[Long_Cycle_WebCam][TxCAMTex*TyCAMTex*3];
        int    LastkWri;        // On n'a qu' prendre la prcdente
        bool   Paused;          // LU    par la source    ECRIT par la dest
        int    kAcCam;          // ECRIT par la source       LU par la dest
	int    LastkAcCam;      // ?? ECRIT par la source       LU par la dest

        bool   TexCree;         //   RIEN par la source        ECRIT par la dest
        GLuint TexCam;          //   RIEN par la source        ECRIT par la dest  ( TWebCamDst::Init(); )

        void glTextureCam();    // utilis par dest uniquement
};
//-------------------------------------------------------
class TWebCamDst
{public :
        TWebCamData * WCF;
        void glTextureCam() {if (WCF) WCF->glTextureCam();}
        bool Init();    // initialise la Tex de TWebCamData

        TWebCamDst() {}
private :
        TWebCamData* Create(int NbOctets);
        HWND            hmem;
} extern WCDst;
//-------------------------------------------------------

struct TXLoader {
    void LoadTxTyBMP (string NomFich,int &Tx,int &Ty);
    void LoadBMP (string NomFich,uchar* &PtIma/*TO BE MALLOCED!!!!*/,int &Tx,int &Ty,int NbCh);
    void FlipRB(void* buffer,int NbPixels,int NbCh)		;
    void LoadBMPAlpha (string Filename,uint * IdxTexture);
    void LoadBMP    (string Filename,uint * IdxTexture);
    void LoadBMPSpr (string Filename,uint * IdxTexture);
    void Reverse    (uchar* &PtIma, int tx,int ty, int NbCh);

} extern XLoader;



#endif
