#include "XDSFree.h"
#include "KTime.h"
#include "XCSGL.h"
#include "XCSSon.h"
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE
//#define GLUT_DISABLE_ATEXIT_HACK
#include "glut.h"
#include "SDL.h"
#include "SDL_image.h"
#include <freetype/internal/internal.h>
#include "Nehe_FreeType.h"


struct my_tolower{ char operator()(char c) const { return std::tolower(static_cast<unsigned char>(c));} };
struct my_toupper{ char operator()(char c) const { return std::toupper(static_cast<unsigned char>(c));} };
void Upper(string &s) {transform(s.begin(), s.end(), s.begin(), my_toupper());}
void Lower(string &s) {transform(s.begin(), s.end(), s.begin(), my_tolower());}
//********************************************************************************************
//********************************************************************************************
//********************************************************************************************
const int NBSPRITEMAX = 500;

struct TSprite
{
    GLuint Tex;
    int tx, ty;
    bool Transp;

    void Load(string NomFich, bool transp);
    void Draw      (float x ,float y,  float factX, float factY);
    void Draw      (float x ,float y,  float size1) {Draw(x,y,size1,size1);}
    void DrawCenter(float xC,float yC, float factX, float factY);
    void DrawCenter(float x ,float y,  float size1) {DrawCenter(x,y,size1,size1);}
} Sprite[NBSPRITEMAX];
//----------------------------------------------------------------
//void TestSpr(bool trans){ if (trans) gl.EnableSpr(); else gl.DisableSpr();}
void TestSpr(bool trans){ if (trans) gl.EnableBlend(); else gl.DisableBlend();}
//----------------------------------------------------------------
void TSprite::Draw(float x, float y,float factX, float factY)
{
    TestSpr(Transp);   gl.CarrezCST2( x,y+ty*factY,x+tx*factX, y,0,Tex);
}
//----------------------------------------------------------------
void TSprite::DrawCenter(float xC,float yC, float factX, float factY)
{
    TestSpr(Transp);   gl.CarrezCST2Centre( xC, yC, tx*factX,-ty*factY,0,Tex);
}
//----------------------------------------------------------------
void TSprite::Load(string NomFich, bool transp)
{
    if (!Files.Exists(NomFich)) glSortirProprement(NomFich);

    string Ext = XS2.ExtractExt(NomFich);    Lower(Ext);

    uint tex = 0;
    //------ CAS 1 ------
    if (Ext=="bmp")
    {
        if (transp)  XLoader.LoadBMPSpr (NomFich,&tex);
                else XLoader.LoadBMP    (NomFich,&tex);
        XLoader.LoadTxTyBMP(NomFich,tx,ty);
    }

    //------ CAS 2 ------
    if (Ext!="bmp")
    {
        SDL_Surface * surf;
        surf = IMG_Load(NomFich.c_str());
        tx = surf->w; ty=surf->h;

        glGenTextures(1, &tex);
        glBindTexture( GL_TEXTURE_2D,tex);
        glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
        glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
        SDL_LockSurface(surf);
        if (Ext=="png") {glTexImage2D ( GL_TEXTURE_2D, 0, GL_RGBA8,tx,ty,0,GL_RGBA, GL_UNSIGNED_BYTE,surf->pixels);transp=true;}
                   else
                   {glTexImage2D ( GL_TEXTURE_2D, 0, GL_RGB8,tx,ty,0,GL_RGB, GL_UNSIGNED_BYTE,surf->pixels);transp=false;}
        SDL_UnlockSurface(surf);
        SDL_FreeSurface(surf);
    }

    Transp = transp;
    Tex    = tex;
}
//**********************************************************************************
//**********************************************************************************
//**********************************************************************************
struct Tmpjv
{
    void Init(int w,int h, string Titre);
    void Run();

    void LoadSprite(string NomFich, int idx, bool Trsp=false) {Sprite[idx].Load(NomFich,Trsp);}
    void Draw       (float x , float y , int idx)                    {Sprite[idx].Draw(x,y,1);}
    void Draw       (float x , float y , int idx, float size1)       {Sprite[idx].Draw(x,y,size1);}
    void DrawCenter (float xC, float yC, int idx)                    {Sprite[idx].DrawCenter(xC,yC,1);}
    void DrawCenter (float xC, float yC, int idx, float size1)       {Sprite[idx].DrawCenter(xC,yC,size1);}
    void DrawCenter (float xC, float yC, int idx, float fx,float fy) {Sprite[idx].DrawCenter(xC,yC,fx,fy);}
    void Color(float r, float v, float b)                     {glColor3f(r,v,b);}

    int tx,ty;
} mpjv;

void Reshape(int width, int height)
{
  	glViewport(0,0,width,height);  	glMatrixMode(GL_PROJECTION);  	glLoadIdentity();
  	gluOrtho2D(0,mpjv.tx,0,mpjv.ty);
}

void processMouse(int button, int state, int x, int y)
{
	//int specialKey = glutGetModifiers(); //specialKey == GLUT_ACTIVE_ALT
	if (button == GLUT_LEFT_BUTTON  ) Souris.ButtonL=1-state;
	if (button == GLUT_MIDDLE_BUTTON) Souris.ButtonM=1-state;
	if (button == GLUT_RIGHT_BUTTON ) Souris.ButtonR=1-state;
	Souris.OnMove(x,y);
}

void passivemotion( int x, int y )
{
    Souris.OnMove(x,y);
}
extern void Loop();
void Display()
{
    K.Refresh();
  	Souris.Refresh();
  	XMod.Refresh();

 	glClear(GL_COLOR_BUFFER_BIT |GL_DEPTH_BUFFER_BIT);
    glId();

  	Loop();

    glutSwapBuffers();
    glutPostRedisplay();//Demande de recalculer la scne

}

void Tmpjv::Init(int w,int h, string Titre)
{
    char caca[] = "myprogram";
    char *my_argv[] = { caca , NULL };
    int   my_argc = 1;
    glutInit(&my_argc, my_argv);

    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    glutInitWindowSize(w,h);
    glutCreateWindow(Titre.c_str());
    tx = w; ty = h;
    F.Width  = tx;
    F.Height = ty;

    glutMouseFunc        (processMouse);
    glutMotionFunc       (passivemotion);
    glutPassiveMotionFunc(passivemotion);
    //glutFullScreen(); 	//Optionnel

    glutReshapeFunc(Reshape);
    glutDisplayFunc(Display);

    //-----------------------------
    glEnable (GL_TEXTURE_2D);
    glDisable(GL_DEPTH_TEST);
}

void Tmpjv::Run()
{
    glutMainLoop();
}
