#include "Units/mpjv.h"
int DX0[]={1,1,1,1, 0,1,2,3}; int DX1[]={1,1,1,2, 2,1,0,0, 1,1,1,0, 0,1,2,2}; int DX2[]={1,1,1,0, 0,1,2,2, 1,1,1,2, 2,1,0,0};
int DY0[]={0,1,2,3, 1,1,1,1}; int DY1[]={0,1,2,2, 1,1,1,2, 2,1,0,0, 1,1,1,0}; int DY2[]={0,1,2,2, 1,1,1,0, 2,1,0,0, 1,1,1,2};

int DX3[]={0,0,1,1, 0,1,1,2}; int DX4[]={1,1,0,0, 0,1,1,2}; int DX5[]={0,0,1,1};
int DY3[]={0,1,1,2, 1,1,0,0}; int DY4[]={0,1,1,2, 0,0,1,1}; int DY5[]={0,1,0,1};

int DX6[]={0,1,2,1, 1,1,1,2, 0,1,2,1, 1,1,1,0};
int DY6[]={1,1,1,0, 0,1,2,1, 1,1,1,2, 0,1,2,1};

int NBROT[7] = {2, 4, 4, 2, 2, 1, 4};
bool GO = false;
int Spd = 0; // de 0  2
int NbJ = 0; // de 1  3
float TDELTA[3] = {900,600,300};
const int NBCX = 10;
const int NBCY = 20;
const int TCXY = 20; // taille des cases en pixels

#define IIDX(a,b) if (idxP==a) DX=b
#define IIDY(a,b) if (idxP==a) DY=b
struct TTetris
{
    int XB,YB;              // position du Ttris
    int Score;
    bool Perdu;

    int k_up, k_down, k_left, k_right, k_down2;

    int Rot;                // Rotation de la pice actuelle
    int PosX,PosY;          // Position pice actuelle
    int idxP,NxtidxP;       // Pice actuelle / next, de 0  6
    float tLastMove;        // date  laquelle la pice a boug
    float tDelta;           // temps pour chaque descente de 1 de la pice act

    int Cases[NBCX][NBCY];  // -1 ou numro de pice ( de 0  6 )

    void Init(int kJ);
    void NewPiece();
    void MoveDownPiece();
    int  DXPiece(int k) { int * DX = DX0; IIDX(1,DX1); IIDX(2,DX2); IIDX(3,DX3); IIDX(4,DX4); IIDX(5,DX5); IIDX(6,DX6);     return(DX[k+4*Rot]);}
    int  DYPiece(int k) { int * DY = DY0; IIDY(1,DY1); IIDY(2,DY2); IIDY(3,DY3); IIDY(4,DY4); IIDY(5,DY5); IIDY(6,DY6);     return(DY[k+4*Rot]);}
    bool CognePiece();
    void DrawCase(int x, int y, int Color);
    void DownPiece();
    void TestLignes();
    void ImprimePiece(); // et passe  la suivante
    void DrawPiece()    { for (int k=0; k<4; k++) DrawCase(PosX+DXPiece(k), PosY+DYPiece(k), idxP);}
    void DrawPiece(int pX, int pY, int idx, int rot) {
        int ox=PosX; int oy=PosY; int id=idxP; int oRot=Rot;
        PosX=pX; PosY=pY; idxP=idx; Rot=rot; DrawPiece();
        PosX=ox; PosY=oy; idxP=id;  Rot=oRot;}
    void Draw();
} Tetris[3];

TTFont ttf[10];
//--------------------------------------------------------------------------------------
void TTetris::DrawCase(int x, int y, int Color){   if (Color==-1) return;    mpjv.Draw( x*TCXY + XB, y*TCXY + YB, Color+2, 0.5 );}
void TTetris::ImprimePiece() { for (int k=0; k<4; k++) Cases[PosX+DXPiece(k)][PosY+DYPiece(k)] = idxP; TestLignes(); NewPiece();}
void TTetris::DownPiece()    { int nb=0; if (!CognePiece()) {while (!CognePiece()) {PosY--;nb++;} PosY++;}   Score+=(nb+5)*10;ImprimePiece();}
void TTetris::MoveDownPiece(){ tLastMove+=tDelta; PosY--;if (CognePiece()) {PosY++;ImprimePiece();} }
void TTetris::NewPiece()
{
    idxP    = NxtidxP;
    NxtidxP = rand()%7;
    PosX = 5;
    PosY = NBCY-4;
    Rot  = 0;
    tLastMove = tact-0.0001;
    if (CognePiece()) Perdu=true;
}
bool TTetris::CognePiece()
{
    for (int k=0; k<4; k++)
    {
        int CX = PosX+DXPiece(k);
        int CY = PosY+DYPiece(k);
        if ( CX<0 || CX>=NBCX || CY>=NBCY || CY<0 ) return(true);
        if ( Cases[CX][CY]!=-1 ) return(true);
    }
    return(false);
}
void TTetris::TestLignes()
{   int kyFULL;
    int nb=0;
    do
    {   kyFULL = -1;
        for (int ky=0; ky<NBCY; ky++) // On check toutes les lignes
        {
            int NbFull=0; for (int kx=0; kx<NBCX; kx++) if (Cases[kx][ky]>=0) NbFull++;
            if (NbFull==NBCX) kyFULL=ky;
        }
        if (kyFULL!=-1) // on a trouv une ligne pleine ! GG ! On dcale tout.
        {   nb++;
            for (int ky=kyFULL; ky<NBCY-1; ky++) for (int kx=0; kx<NBCX; kx++) Cases[kx][ky]=Cases[kx][ky+1];
            for (int kx=0;      kx<NBCX;   kx++) Cases[kx][NBCY-1] = -1;
        }
    } while (kyFULL!=-1);
    Score+= nb*nb*100;
}
void TTetris::Init(int kJ)
{
    for (int kx=0; kx<NBCX; kx++)
    for (int ky=0; ky<NBCY; ky++) Cases[kx][ky]=-1;
    if (NbJ==1) XB = 300;
    if (NbJ==2) XB = 200 + 400*kJ;
    if (NbJ==3) XB = 30  + 350*kJ;
    YB = 40;
    int keysJ1[] = {K_Z, K_Q, K_S, K_D, K_X};
    int keysJ2[] = {K_Y, K_G, K_H, K_J, K_B};
    int keysJ3[] = {K_CN8, K_CN4, K_CN5, K_CN6, K_CN2};
    int * key = keysJ1; if (kJ==1) key=keysJ2; if (kJ==2) key=keysJ3;

    k_up = key[0]; k_left = key[1]; k_down = key[2];  k_right=key[3]; k_down2=key[4];

    Perdu     = false;
    tLastMove = tact;
    NxtidxP   = rand()%7;
    tDelta    = TDELTA[Spd];
    Score     = 0;
    NewPiece();
}
void TTetris::Draw()
{
    //***************** CONTROLES
    if (!Perdu)
    {
        if (tact > tLastMove+tDelta) MoveDownPiece();
        if (KTime[k_up]       ==1) {int ORot=Rot; Rot++;if (Rot>=NBROT[idxP]) Rot=0;if (CognePiece()) Rot=ORot;}
        if (KTime[k_right]%10 ==1) {PosX++; if (CognePiece()) PosX--;}
        if (KTime[k_left] %10 ==1) {PosX--; if (CognePiece()) PosX++;}
        if (KTime[k_down]     ==1) {DownPiece();}
        if (KTime[k_down2]    >=1) {tDelta=50;} else {tDelta=TDELTA[Spd];}
        if (KTime[k_down2]    ==1) {tLastMove=tact-tDelta;}
    }

    //***************** DESSIN
    mpjv.Draw(XB,YB,9);     // --- 1 --- le fond du ttris
    DrawPiece();            // --- 2 --- la pice en cours
    for (int kx=0; kx<NBCX; kx++)
    for (int ky=0; ky<NBCY; ky++) DrawCase(kx,ky,Cases[kx][ky]);
    int xx  = XB +  90;
    int yy  = YB + 410 + 110;
    int yy2 = YB + 410 +  25;
    mpjv.DrawCenter(xx,yy ,11,0.5,0.4);  ttf[1].Print(xx-70,yy -8,"Score : "+XS.IntToStr(Score),0.8);
    mpjv.DrawCenter(xx-30,yy2,11,0.4,0.3);  ttf[1].Print(xx-80,yy2-8,"PIECE A VENIR :",0.75);
    XB+=20; YB+=10;
    DrawPiece(7, NBCY, NxtidxP, 0);
    XB-=20; YB-=10;

    if (Perdu && K.sact(1)>=0 ) ttf[1].PrintCenter(XB+100, YB+200,"Perdu !!!",1.4);
}
//--------------------------------------------------------------------------------------
void Bouton(int x, int y,string Txt,int action)
{
    float FF = 0.7;
    float TX = Sprite[12].tx*FF;
    float TY = Sprite[12].ty*FF;
    if (action && Souris.In(x-TX/2, y-TY/2, x+TX/2, y+TY/2))
    {
        mpjv.Color(0,1,1);
        if (Souris.MTime[M_LEFT]==1)
        {
            if (action<=3) {NbJ=action;for (int k=0; k<3; k++) Tetris[k].Init(k);GO=true;}
            if (action==4) Spd++; if (Spd==3) Spd=0;
            if (action==5) exit(0);
            if (action==6) GO=false;
        }
    }
    if (action==4 && Spd==0) Txt+="lent";
    if (action==4 && Spd==1) Txt+="normal";
    if (action==4 && Spd==2) Txt+="rapide";
    mpjv.DrawCenter(x,y,(action==0?13:12),FF);
    mpjv.Color(0,0,1);
    ttf[0].PrintCenter(x,y,Txt,(action? (action==4?0.8:1):0.65));
    mpjv.Color(1,1,1);
}
void AffMenu()
{
    mpjv.Draw( 0,0,1 );
    int yy1=600;
    int yy2=yy1-100;
    int yy3=yy1-200;
    int xx=300; int xx2=700;
    Bouton (xx,yy1,"1 JOUEUR" ,1);  Bouton (xx2,yy1,"  Touches J 1 : Z Q S D X" ,0);
    Bouton (xx,yy2,"2 JOUEURS",2);  Bouton (xx2,yy2,"  Touches J2 : Y G H J B" ,0);
    Bouton (xx,yy3,"3 JOUEURS",3);  Bouton (xx2,yy3,"  Touches J3 : 8 4 5 6 2" ,0);

    float xC = 500;
    Bouton (xC,250," Vitesse : ",4);
    Bouton (xC,100,"QUITTER",5);
}
//**************************************************************************************
//**************************************************************************************
void Loop()
{
    if (!GO) AffMenu(); else
    {
        mpjv.Draw( 0,0,0 );  Bouton (850,mpjv.ty-100,"    Echap : retour",6);
        for (int k=0; k<NbJ; k++) Tetris[k].Draw();
    }

    //--- Commun
    mpjv.DrawCenter( mpjv.tx/2-(GO?150:0), mpjv.ty-50, 10, 0.7, 0.5); // Titre

    //--- Clavier Souris
    if (KTime[K_ESC]==1) {if (GO) GO=false; else exit(0);}
}
//**************************************************************************************
//**************************************************************************************
int main( int argc, char *argv[ ] )
{
    //------------------------------------------------------
    mpjv.Init(1024,768,"04-Ttris");
    mpjv.LoadSprite("Images/background1.jpg" , 0);    mpjv.LoadSprite("Images/background2.jpg" , 1);

    mpjv.LoadSprite("Images/Picture0.png" , 2,true);    mpjv.LoadSprite("Images/Picture1.png" , 3,true);
    mpjv.LoadSprite("Images/Picture2.png" , 4,true);    mpjv.LoadSprite("Images/Picture3.png" , 5,true);
    mpjv.LoadSprite("Images/Picture4.png" , 6,true);    mpjv.LoadSprite("Images/Picture5.png" , 7,true);
    mpjv.LoadSprite("Images/Picture6.png" , 8,true);

    mpjv.LoadSprite("Images/terrain.jpg" , 9);
    mpjv.LoadSprite("Images/titre.png"   ,10,true);
    mpjv.LoadSprite("Images/barre2.png"   ,11,true);
    mpjv.LoadSprite("Images/barre3.png"   ,12,true);
    mpjv.LoadSprite("Images/barre4.png"   ,13,true);

    //------------------------------------------------------
    ttf[0].LoadFont_FT("Images/lego.ttf"   ,21);
    ttf[1].LoadFont_FT("Images/bebas.ttf"  ,21);

    //------------------------------------------------------
    mpjv.Run();
    return(1);
}
